#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	AddCategory.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:26	N		Original version
##
##*****************************************************************************

# The Add Category form will invoke this cgi. This will add the category with specified field and 
# indicate to the user of add was successful.


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "ShowCategories.pl";
require "DocUtils.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kEditMode);

# Read the input (from the form)
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("name");

# List of all arguments.
@kAllArguments = ("name", "parent", "description", "iconurl");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$result = $errNone;
$name = $userAssocRecord{$kAllArguments[0]};
$description = $userAssocRecord{$kAllArguments[2]};
$gAssocList{"Name"} = $name;
$gAssocList{"Description"} = $description ? $description : "";

if (!&IsCatDocNameInProperCharSet($name)) {
	$gAssocList{"NAMENOTINCHARSET"} = 1;
	$gAssocList{"PreviousCatAdded"} = "";
	$gAssocList{"AddCategory"} = $name;
	$result = 1;
}

if ($result == $errNone) {
	$parent = $userAssocRecord{$kAllArguments[1]};
	if (!defined($parent)) {
		$parent = $kRootCategoryID;
	}
	$result = &OPAddCategory($name, $parent, $userAssocRecord{$kAllArguments[2]}, $userAssocRecord{$kAllArguments[3]});
	$gAssocList{"PreviousCatAdded"} = &EncodeForURL($name);

	if ($result != $errNone) {
		$gAssocList{"PreviousCatAdded"} = "";
		$gAssocList{"ADDERROR"} = 1;
		$gAssocList{"AddCategory"} = $name;
		if($result == $errParentDoesNotExist) {
			$gAssocList{"errNoParent"} = 1;
			$gAssocList{"ParentCategory"} = &GetCategoryPath($parent, 1);
#			$parent = $kRootCategoryID; #reset parent to root so ShowCategories will show Top level now!
		}
		elsif ($result == $errCategoryInParent) {
			$gAssocList{"ParentCategory"} = &GetCategoryPath($parent, 1);
			$gAssocList{"errCategoryInParent"} = 1;
		}
		else {
			if($result == $errDuplicateCategory) {
				$gAssocList{"errDuplicateCategory"} = 1;
			}
		}
	}
	else { #add successful
		$gAssocList{"Name"} = "";
		$gAssocList{"Description"} = "";
	}#else
}

$gAssocList{"ParentList"} = &GetCategoryParentSelectList($parent, -1);#self not applicable
$templateFile = $kDocDocPagePath . $kDocAddCategoryTemplate;
$gAssocList{"Parent"} = $parent;
$gAssocList{"DefaultIcon"} = $kDefaultCategoryIconURL;
&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);

exit 0;
