#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	AddDocument.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:26	N		Original version
##
##*****************************************************************************

# The Add Document form will invoke this cgi. This will add the document with specified field and 
# indicate to the user of add was successful.


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "ShowDocuments.pl";
require "Listing.pl";
require "DocUtils.pl";
require "UploadFile.pl";
# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kEditMode);

# Read the input (from the form)
# $lineread = &ReadQueryString();
# above is replaced by upload file version ...

# Create an associative list of (key value) pair
# of the input
local(%userAssocRecord,
      %cgi_cfn,
      %cgi_ct,
      %cgi_sfn);

#&MakeAssociativeList($lineread, *userAssocRecord);
$ret = &GetUploadedFileWithCGIInput(*userAssocRecord, *cgi_cfn, *cgi_ct, *cgi_sfn, $kDocTmpPath);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("name", "parents", "urlorfile", "author", "apptype");

# List of all arguments.
@kAllArguments = ("name", "parents", "realurl", "author", "size", "apptype", "keywords", "description", "urlconfirm", "upfile", "urlorfile", "version");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

my($userID) = $gAssocList{$kUserIDCookie};

my($docLoc) = $userAssocRecord{$kAllArguments[10]};#one of 'file', 'url' or 'desc'
my($url) = $userAssocRecord{$kAllArguments[2]};
$urlconfirm = $userAssocRecord{$kAllArguments[8]} eq 'yes';

my($uploadFailed) = 0;

# Check for upload file or simple url ...
$isupload = $userAssocRecord{$kAllArguments[10]} eq 'file';
if ($isupload) {
    $clientfilename = &ExtractJustFileName($cgi_cfn{$kAllArguments[9]});
    $serverfilename = $cgi_sfn{$kAllArguments[9]};
    $destfile = &GenerateUniqueFileName($kDocDBRootPath . "docs/", $clientfilename);
    $destfullpath = $kDocDBRootPath . "docs/" . $destfile;
    $url = "\$INFOBASE/" . $destfile;
    #&CopyFile($serverfilename,  $destfullpath);
    #unlink($serverfilename);
	if (!(-f $serverfilename)) {
		$uploadFailed = 1;
	}
	else {
		rename($serverfilename,  $destfullpath);
		$urlconfirm = 1;
	}
}
else {
	$serverfilename = $cgi_sfn{$kAllArguments[9]};
	unlink($serverfilename);
}

$ie3 = ($ENV{ 'HTTP_USER_AGENT' } =~ /MSIE 3/) ? 1 : 0;
if ($ie3) {
	$gAssocList{"BROWSERIE3"} = 1;
}

$name = $userAssocRecord{$kAllArguments[0]};
$parents = $userAssocRecord{$kAllArguments[1]};
$version = $userAssocRecord{$kAllArguments[11]} ? $userAssocRecord{$kAllArguments[11]} : 1;
$prevVersionDocID = 0;

my($count) = 0;
local(@sameurldocs) = ();

if($docLoc eq 'desc') {
	$url = '';
}
elsif($docLoc eq 'url') {
	if (!$urlconfirm) {
		$count = &OPGetDocsForURL($url, 0, *sameurldocs);
	}
}

@rest = ($userAssocRecord{$kAllArguments[3]}, $url, $userAssocRecord{$kAllArguments[4]}, 
	$userAssocRecord{$kAllArguments[5]}, $version, $prevVersionDocID,
	$userAssocRecord{$kAllArguments[6]}, $userAssocRecord{$kAllArguments[7]});

# $parents may be "," or "\0", handle both cases

@givenParents = split("\0", $parents);
if ($#givenParents == 0) { # if only one parent, then try spliting with ","
 @givenParents = split($kValueSeperator, $parents);
}
local(@categories) = @givenParents;

$gAssocList{"ParentList"} = &GetDocumentParentSelectList(*givenParents);
$gAssocList{"Name"} = $name;
$gAssocList{"Author"} = $userAssocRecord{$kAllArguments[3]};
$gAssocList{"DefaultURL"} = $userAssocRecord{$kAllArguments[2]};
$gAssocList{"Description"} = $userAssocRecord{$kAllArguments[7]} ? $userAssocRecord{$kAllArguments[7]} : "";
$gAssocList{"Keywords"} = $userAssocRecord{$kAllArguments[6]} ? $userAssocRecord{$kAllArguments[6]} : "";
$gAssocList{"CategoryName"} = "";
$gAssocList{"PreviousDocAdded"} = "";
$gAssocList{"Parent"} = "";
$gAssocList{"CurrentURL"} = $url;
$gAssocList{"Version"} = $version;
$gAssocList{"CurrentFile"} = "";

if ($uploadFailed) {
    $gAssocList{"UPLOADFAILED"} = 1;
	$gAssocList{"AddDocument"} = $name;
    $gAssocList{'URLConfirm'} = 'no';
    $gAssocList{"CurrentURL"} = "";
    $gAssocList{'FIRSTTIMEADD'} = 1;
    $templateFile = $kDocDocPagePath . $kDocAddDocumentTemplate;
    &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);   
   exit 0;
}

if (!&IsCatDocNameInProperCharSet($name)) {
	$gAssocList{"NAMENOTINCHARSET"} = 1;
	$gAssocList{"AddDocument"} = $name;
    $gAssocList{'URLConfirm'} = 'no';
    $gAssocList{'FIRSTTIMEADD'} = 1;
    $templateFile = $kDocDocPagePath . $kDocAddDocumentTemplate;
    &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
    if ($isupload) {
       unlink($destfullpath);
    }
    exit 0;
}

if ($count) {
    # implies there are docs with same url ...
    # repost the form with the msg ...
    $gAssocList{'DOCTABLEEXISTS'} = 1;
    $gAssocList{'SECONDTIMEADD'} = 1;
    $gAssocList{'URLConfirm'} = 'yes';

    $doctext = "";
    &BuildDocumentTableCells2(*sameurldocs, $userID, *doctext);
    $gAssocList{"DocList"} = $doctext;
    $templateFile = $kDocDocPagePath . $kDocAddDocumentTemplate;
    &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
    if ($isupload) {
       unlink($destfullpath);
    }
 &LogMsg("AddDoc:: exiting! ");
   exit 0;
}

$parents = join($kValueSeperator, @categories);
local($parent) = $categories[0];

$result = &OPAddDocument($name, $parents, *rest);
$gAssocList{'DocBaseURL'} = $kDocDBRootURL;

local($edit) = "true";
if ($result == $errNone) {
    $gAssocList{'FIRSTTIMEADD'} = 1;
    $gAssocList{'URLConfirm'} = 'no';
	$gAssocList{"PreviousDocAdded"} = &EncodeForURL($name);
	$gAssocList{"Parent"} = $parent;
	# for next document add, make some of the fields null
	$gAssocList{"Name"} = '';
	$gAssocList{"CurrentURL"} = '';
	$gAssocList{"Description"} = '';
	$gAssocList{"Keywords"} = '';
   $templateFile = $kDocDocPagePath . $kDocAddDocumentTemplate;
    &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
    # &ShowDocuments($parent, $edit, *gAssocList);
}
else {
    $gAssocList{"ADDERROR"} = 1;
    $gAssocList{"AddDocument"} = $name;
    if ($result == $errParentDoesNotExist) {
	    $gAssocList{"errNoParent"} = 1;
	    $gAssocList{"ParentCategory"} = $parent;
	    $parent = $kRootCategoryID; #reset parent to root so ShowDocuments will show Top level now!
    }
    &ShowDocuments($parent, $edit, *gAssocList);
}

exit 0;
