#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	AddGlossary.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:26	N		Original version
##
##*****************************************************************************

# The Add Glossary form will invoke this cgi. This will add the Glossary term with
# specified def. and indicate to the user if add was successful.


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "Glossary.pl";
require "DocUtils.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kEditMode);

# Read the input (from the form)
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ($kGlossaryDBFields[$kGlossaryTermIndex], $kGlossaryDBFields[$kGlossaryDefinitionIndex]);

# List of all arguments.
@kAllArguments = ($kGlossaryDBFields[$kGlossaryTermIndex], $kGlossaryDBFields[$kGlossaryDefinitionIndex]);

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);


$term = $userAssocRecord{$kAllArguments[0]};
$def = $userAssocRecord{$kAllArguments[1]};
$gAssocList{'Term'} = $term;
$gAssocList{'Definition'} = $def;

if (!&IsNameInProperCharSet($term)) {
	$gAssocList{"NAMENOTINCHARSET"} = 1;
	$gAssocList{"AddTerm"} = $term;
	$gAssocList{'PrevTermAdded'} = "";
	$result = 1;
}
else {
	$result = &OPAddGlossary($term, $def);
	$gAssocList{"Message"} = "";
	if ($result != $errNone) {
		$gAssocList{"ADDERROR"} = 1;
		$gAssocList{"AddTerm"} = $term;
		if($result == $errDuplicateGlossary) {
			$gAssocList{"errDuplicateGlossary"} = 1;
		}
		$gAssocList{'PrevTermAdded'} = "";
	}
	else {
		$gAssocList{'Term'} = '';#blank off if successful for next addition
		$gAssocList{'Definition'} = '';#blank off if successful for next addition
		$gAssocList{'PrevTermAdded'} = $term;
	}
}
$templateFile = $kDocDocPagePath . $kDocAddGlossaryTemplate;
&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);

exit 0;
