#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	AddUser.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:26	N		Original version
##
##*****************************************************************************

# The Add Glossary form will invoke this cgi. This will add the Glossary term with
# specified def. and indicate to the user if add was successful.


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "ShowUsersUtils.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kAdminMode);

# Read the input (from the form)
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("userid", "password", "name", "email", "type");

# List of all arguments.
@kAllArguments = ("userid", "password", "name", "email", "type", "groups");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);


$userid = $userAssocRecord{$kAllArguments[0]};
$password = $userAssocRecord{$kAllArguments[1]};
$name = $userAssocRecord{$kAllArguments[2]};
$email = $userAssocRecord{$kAllArguments[3]};
$type = $userAssocRecord{$kAllArguments[4]};
$groups = $userAssocRecord{$kAllArguments[5]};

local(@userRecord) = ($userid, $password, $type, $groups, "", "");
local(@userProfileRecord) = ($userid, $name, $email, "", $kUMDefaultOtherPrefs);
$result = &UMAddUser(*userRecord); #doesn't encrypt password
$result = $result || &UMUpdateUserPassword($userid, $password);#encrypts password
$result = $result || &UMAddUserProfile(*userProfileRecord);
foreach $group (split($kValueSeperator, $groups)) {
    $result = $result || &UMAddUserToGroup($group, $userid, 0, 1);
}
$gAssocList{"Message"} = "";
if ($result == $errNone) {
    &ShowUsers(*gAssocList);
}
else {
    $gAssocList{"ADDERROR"} = 1;
    $gAssocList{"AddUserID"} = $userid;
    if($result == $errDuplicateUser) {
		$gAssocList{"errDuplicateUser"} = 1;
    }
    &ShowUsers(*gAssocList);
}

exit 0;
