#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	ChangePassword.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	01/31/97	13:25	Thyag	Original version
##
##*****************************************************************************

# This cgi will change the password for a given userid


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("OldPassword", "NewPassword");

# List of all arguments.
@kAllArguments = ("OldPassword", "NewPassword");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$oldPassword = $userAssocRecord{$kAllArguments[0]}; 
$newPassword = $userAssocRecord{$kAllArguments[1]};

$sessionID = $gAssocList{$kSessionIDCookie};
$userID = $gAssocList{$kUserIDCookie};
if ($userID) {
    $result = &UMVerifyUser($userID, $oldPassword);
    if ($result == $errNone) {
		$result = &UMUpdateUserPassword($userID, $newPassword);
		if ($result != $errNone) {
			$gAssocList{"NOTCHANGEDERROR"} = 1;
		}
		else {
			$gAssocList{"CHANGESUCCESS"} = 1;
		}
    }
    else {
		$gAssocList{"OLDPASSWORDINVALID"} = 1;
    }
}
else {
    &OutputHTMLMsg("Error", "Error: Invalid SessionID");
    exit 1;
}

$templateFile = $kDocDocPagePath . $kDocChangePasswordTemplate;
&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);

exit 0;

