#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	CreateCustomInfobase.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Milpitas, CA, USA, 1998.
##     			Not to be copied, modified or redistributed without written
##     			permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	07/14/98	13:17	N		Original version
##
##*****************************************************************************

# This cgi will display a Login page

# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocDB.pl";
require "DocUtils.pl";
require "CreateInfobase.pl";
require "UMAPI.pl";
require "UMProfileAPI.pl";

# --------------------------------------------------------------------------------
# Write version file
sub WriteVersionFile
{
	if (!open(VERSIONFILE, ">$kVersionFile")) {
		&LogFileOpenFailMsg($kVersionFile);
		&LogMsg("Version file could be opened !!!");
	}
	else {
		&GetWriteLockOnFile("VERSIONFILE") || &LogMsg("WriteVersionFile: failed on write lock on file $kVersionFile: $!");
		print VERSIONFILE "${kProductVersion}\n${kProductFullVersion}\n";
		close(VERSIONFILE);
		&UnlockFile("VERSIONFILE") || &LogMsg("WriteVersionFile: failed on unlock on file $kVersionFile: $!");
	}	
}

# --------------------------------------------------------------------------------
# Execute ...
#

# *no need* verify user acccess first
#&VerifyUserAccess($kSuperAdminMode);

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("ibname", "userid", "password");

# List of all arguments.
@kAllArguments = ("userid", "password", "ibname", "description", "username");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$userid = $userAssocRecord{$kAllArguments[0]};
$password = $userAssocRecord{$kAllArguments[1]};
$ibname = $userAssocRecord{$kAllArguments[2]};
$ibdesc = $userAssocRecord{$kAllArguments[3]};
$username = $userAssocRecord{$kAllArguments[4]};

$result = &CreateInfobase($ibname, $ibdesc, '', '');

if ($result == $errNone) {
	my($type) = "$kAdminMode"; #admin user
	my($groups) = 'admin';
	my($email) = '';
	local(@userRecord) = ($userid, $password, $type, $groups, "", "");
	local(@userProfileRecord) = ($userid, $username, $email, "", $kUMDefaultOtherPrefs);
	$result = &UMAddUser(*userRecord); #doesn't encrypt password
	$result = $result || &UMUpdateUserPassword($userid, $password);#encrypts password
	$result = $result || &UMAddUserProfile(*userProfileRecord);
}

$gAssocList{'UserID'} = $userid;
$gAssocList{'IBName'} = $ibname;
$gAssocList{'Description'}  = $ibdesc;

if ($result == $errNone) {
    $templateFile = $kDocMsgPagePath .  'msgCustomIBCreate.htm';
    &GenerateHTMLPage($templateFile, *gAssocList, $kDocMsgPagePath);
}
else {
    $templateFile = $kDocDocPagePath .  $kDocDBCreateTemplate;
   &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}

exit 0;
