#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	CreateDatabase.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     			Not to be copied, modified or redistributed without written
##     			permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/28/96	13:17	N		Original version
##
##*****************************************************************************

# This cgi will display a Login page

# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocDB.pl";
require "DocUtils.pl";
require "CreateInfobase.pl";

# --------------------------------------------------------------------------------
# Write version file
#sub WriteVersionFile
#{
#	if (!open(VERSIONFILE, ">$kVersionFile")) {
#		&LogFileOpenFailMsg($kVersionFile);
#		&LogMsg("Version file could be opened !!!");
#	}
#	else {
#		&GetWriteLockOnFile("VERSIONFILE") || &LogMsg("WriteVersionFile: failed on write lock on file $kVersionFile: $!");
#		print VERSIONFILE "${kProductVersion}\n${kProductFullVersion}\n";
#		close(VERSIONFILE);
#		&UnlockFile("VERSIONFILE") || &LogMsg("WriteVersionFile: failed on unlock on file $kVersionFile: $!");
#	}	
#}

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kSuperAdminMode);

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("name");

# List of all arguments.
@kAllArguments = ("name", "path", "url", "description", "location", "defaultpath", "defaulturl");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$dbname = $userAssocRecord{$kAllArguments[0]};
if($userAssocRecord{$kAllArguments[4]} eq "default") { # location
	$dbpath = $userAssocRecord{$kAllArguments[5]}; #use default
	$dburl = $userAssocRecord{$kAllArguments[6]};
}#if
else {
	$dbpath = $userAssocRecord{$kAllArguments[1]};
	$dburl = $userAssocRecord{$kAllArguments[2]};
}#else
if (!$dbpath) {
	$dbpath = $kDefaultBaseIBPath;
}
if (!$dburl) {
	$dburl = $kDefaultBaseIBURL;
}
$dbpath =~ tr/\\/\//;
if ($dbpath !~ /^.+\/$/) {
	$dbpath = $dbpath . "/"; #make it end with a slash
}
if ($dburl !~ /^.+\/$/) {
	$dburl = $dburl . "/"; #make it end with a slash
}
$dbdesc = $userAssocRecord{$kAllArguments[3]} ? $userAssocRecord{$kAllArguments[3]} : "";
$result = $errNone;
$result = &CreateInfobase($dbname, $dbdesc, $dbpath, $dburl);

##################################################
#if (!&IsNameInProperCharSet($dbname)) {
#	$gAssocList{"NAMENOTINCHARSET"} = 1;
#	$gAssocList{"AddInfobase"} = $dbname;
#	$result = 2;
#}
#
#$msg = "";
#%dbassoc = ();
#%dburlassoc = ();
#&ReadDatabaseNames(\%dbassoc, \%dburlassoc);
#my(@keys) = keys %dbassoc;

### Future improvement:
## Need to lock the Infobases file so no one else will 
## change the last index
##
#my($numDB) = &ReadLastDBDirIndex() + 1; 
#my($dbDirName) = "DB" . $numDB;
#my($completePath) = $dbpath . $dbDirName;

#if (($result == $errNone) && ($dbassoc{$dbname})) {
#    $result = 1;
#	$gAssocList{"errDuplicateInfobase"} = 1;
#	$gAssocList{"ADDERROR"} = 1;
#}

#if ($result == $errNone) {
#	while (-d $completePath) { #if directory exists bump the number
#		$numDB++;
#		$dbDirName = "DB" . $numDB;
#		$completePath = $dbpath . $dbDirName;
#	}
#	
#	$result = 1;
#    umask 0000;
#    if (mkdir($completePath, $kDBDefaultPermission) == 1) { # success
#		$result = $errNone;
#	}
#	else {
#		$gAssocList{"ADDERROR"} = 1;
#		$gAssocList{"errPermission"} = 1;
#	}
#	if ($result == $errNone) {
#		mkdir("${completePath}/db", $kDBDefaultPermission);
#		mkdir("${completePath}/docs", $kDBDefaultPermission);
#		my($url) = "${dburl}${dbDirName}/";
#		my($db) = "${completePath}/";
#		
#		# set all globals to point to new infobase ...
#		&SetAllGlobals($db, $url);
#		
#		$result = &DefineAllDBs();
#		if ($result == $errNone) {
#			# write defaults config file ...
#			&WriteInfobaseConfigFile();
#			# write version file ...
#			&WriteVersionFile();

#			my(%assoc) = ();
#			# add to the InfoBases config file
#			&ReadSpecifiedConfigFile($kInfobasesConfigFile, \%assoc);
#			$assoc{"lastindex"} = $numDB;
#			#append directory if it is not in a default location
#			if($completePath !~ /^$kDefaultDBPath/) {
#				$assoc{"directory" . $numDB} = $db;
#				$assoc{"url" . $numDB} = $url;
#			}#if
#			&WriteSpecifiedConfigFile($kInfobasesConfigFile, \%assoc);
#			# add name, description to the infobase.config file
#			%assoc = ();
#			$assoc{"name"} = $dbname;
#			$assoc{"description"} = $dbdesc;
#			&WriteSpecifiedConfigFile($kDocDBRootPath . $kIBInfobaseFileName, \%assoc);
#		}
#	}
#}
###################################################################

if ($result == $errNone) {
    $templateFile = $kDocMsgPagePath .  $kMsgAllAdminOpSuccessfullTemplate;
    local(%assocList) = ();
	$assocList{"CloseOnLoad"} = "true";# close the window after loading
    &GenerateHTMLPage($templateFile, *assocList, $kDocMsgPagePath);
}
else {
    $templateFile = $kDocDocPagePath .  $kDocDBCreateTemplate;
	$gAssocList{'Name'} = $dbname;
	$gAssocList{'Description'}  = $dbdesc;
	$gAssocList{'DefaultPath'} = $kDefaultDBPath;
	$gAssocList{'DefaultURL'} = $kDefaultDBURL;
   &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}

exit 0;
