#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	EditCategory.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:26	N		Original version
##
##*****************************************************************************

# The Submit button from the Edit Form for Categories will invoke this cgi.
# This will output a new read only detailed view of the category.



# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "ShowCategories.pl";
require "ShowFormView.pl";
require "DocUtils.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kEditMode);

# Read the input (from the form)
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("name", "xparent", "categoryID");

# List of all arguments.
@kAllArguments = ("name", "xparent", "description", "iconurl", "categoryID", "oldname");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$name = $userAssocRecord{$kAllArguments[0]};

$categoryID = $userAssocRecord{$kAllArguments[4]};
$oldName = ($userAssocRecord{$kAllArguments[5]} ? $userAssocRecord{$kAllArguments[5]} : "");

local(@recordx) = ();
$recordx[$kCategoryIDIndex] = $categoryID;
$recordx[$kCategoryNameIndex] = $name;
$recordx[$kCategoryParentIndex] = $userAssocRecord{$kAllArguments[1]};
$recordx[$kCategoryDescIndex] = $userAssocRecord{$kAllArguments[2]} ? $userAssocRecord{$kAllArguments[2]} : "";
$recordx[$kCategoryIconURLIndex] = $userAssocRecord{$kAllArguments[3]};

if (!&IsCatDocNameInProperCharSet($name)) {
	$gAssocList{"NAMENOTINCHARSET"} = 1;
	$gAssocList{"EditCategory"} = $name;
	$gAssocList{'editsuccess'} = 0; #needed for JavaScript only for edit saves
	&ShowCategoryForm($categoryID, *recordx, "", *gAssocList);
	exit(0);
}

$result = &OPSetCategory($categoryID, *recordx);
if ($result == $errNone) {
    local($name) = $recordx[$kCategoryNameIndex];
    local(@category) = ();
	$gAssocList{'editsuccess'} = 1; #needed for JavaScript only for edit saves
	if($name ne $oldName) {
		$gAssocList{'Parent'} = $recordx[$kCategoryParentIndex]; # refresh main page
	}
	else {
		$gAssocList{'Parent'} = "";#do not refresh main page
	}
    &ShowCategoryForm($categoryID, *category, "", *gAssocList);
}
elsif ($result == $errEntryNotFound) {
	&RedirectURL("../cgi-bin/StaleObject.pl?obj=Category");
	exit 0;
}
else {
	$gAssocList{'editsuccess'} = 0; #needed for JavaScript only for edit saves
	&ShowCategoryForm($categoryID, *recordx, "Check the Parent value", *gAssocList);
}

exit 0;
