#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	CreateDatabase.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     			Not to be copied, modified or redistributed without written
##     			permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/28/96	13:17	N		Original version
##
##*****************************************************************************

# This cgi will display a Login page

# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocUtils.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kAdminMode);

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("name", "fullpath", "fullurl");

# List of all arguments.
@kAllArguments = ("name", "description", "fullpath", "fullurl", "originalname");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$dbname = $userAssocRecord{$kAllArguments[0]};
$dbdesc = $userAssocRecord{$kAllArguments[1]} ? $userAssocRecord{$kAllArguments[1]} : "";
$dbFullPath = $userAssocRecord{$kAllArguments[2]}; 
$dbFullURL = $userAssocRecord{$kAllArguments[3]}; 
$dbOrigName = $userAssocRecord{$kAllArguments[4]}; 
$dbFullPath =~ tr/\\/\//;
if ($dbFullPath !~ /^.+\/$/) {
	$dbFullPath = $dbFullPath . "/"; #make it end with a slash
}

$result = $errNone;
if (!&IsNameInProperCharSet($dbname)) {
	$gAssocList{"NAMENOTINCHARSET"} = 1;
	$gAssocList{"EditInfobase"} = $dbname;
	$result = 2;
}

$msg = "";
my($completePath) = $dbFullPath;

if (($result == $errNone) && !(-d $completePath)) {
    $result = 1;
	$gAssocList{"InfobaseDir"} = $completePath;
	$gAssocList{"errNoDirectory"} = 1;
}
if(($result == $errNone) && ($dbname ne $dbOrigName)) { #name modified
	%dbassoc = ();
	%dburlassoc = ();
	&ReadDatabaseNames(\%dbassoc, \%dburlassoc);
	if (($result == $errNone) && ($dbassoc{$dbname})) {
		$result = 1;
		$gAssocList{"errDuplicateInfobase"} = 1;
		$gAssocList{"EDITERROR"} = 1;
	}
}#if name modified by user
if ($result == $errNone) {
	my($url) = $dbFullURL;
	my($db) = "${completePath}/";

    # create the db
    $kDocDBRootPath = $db;
    $kDocDBRootURL = $url;

	if ($result == $errNone) {
		my(%assoc) = ();
		# replace name, description to the infobase config file
		&ReadSpecifiedConfigFile($kDocDBRootPath . $kIBInfobaseFileName, \%assoc);
		$assoc{"name"} = $dbname;
		$assoc{"description"} = $dbdesc;
		&WriteSpecifiedConfigFile($kDocDBRootPath . $kIBInfobaseFileName, \%assoc);
	}
}

if ($result == $errNone) {
    $templateFile = $kDocMsgPagePath .  $kMsgAllAdminOpSuccessfullTemplate;
    local(%assocList) = ();
	$assocList{"CloseOnLoad"} = "true";# close the window after loading
    &GenerateHTMLPage($templateFile, *assocList, $kDocMsgPagePath);
}
else {
    $templateFile = $kDocDocPagePath .  $kDocDBEditTemplate;
	$gAssocList{'EditName'} = $dbname;
	$gAssocList{'Name'} = $dbOrigName;
	$gAssocList{'OriginalName'} = $dbOrigName;
	$gAssocList{'Description'}  = $dbdesc;
	$gAssocList{'DefaultPath'} = $kDefaultDBPath;
	$gAssocList{'DefaultURL'} = $kDefaultDBURL;
	$gAssocList{'FullPath'} = $dbFullPath;
	$gAssocList{'FullURL'} = $dbFullURL;
    &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}

exit 0;
