#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	EditDatabaseForm.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     			Not to be copied, modified or redistributed without written
##     			permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	02/14/97	13:17	N		Original version
##
##*****************************************************************************

# This cgi will display a Login page

# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kAdminMode);

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("name");

# List of all arguments.
@kAllArguments = ("name", "fullPath", "url");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$dbname = $userAssocRecord{$kAllArguments[0]};
$dbFullPath = $userAssocRecord{$kAllArguments[1]};
$dbDirURL = $userAssocRecord{$kAllArguments[2]};
if($dbFullPath eq "") {
	%dbassoc = ();
	%dburl = ();
	&ReadDatabaseNames(\%dbassoc, \%dburl);
	$dbFullPath = $dbassoc{$dbname};	
	$dbDirURL = $dburl{$dbname};	
} #if (get db path)

if($dbFullPath eq "") {
	&RedirectURL("../cgi-bin/StaleObject.pl?obj=Infobase");
	exit 0;
    $templateFile = $kDocErrPagePath .  $kErrInternalErrorTemplate;
    local(%assocList) = ("Body", "Failed to find database directory path for '$dbname'");
    &GenerateHTMLPage($templateFile, *assocList, $kDocErrPagePath);

	exit 0;
} #path not available, bail out

$gAssocList{'Name'} = $dbname;
$gAssocList{'OriginalName'} = $dbname;#used if edit fails
$gAssocList{'FullPath'} = $dbFullPath;
$gAssocList{'FullURL'} = $dbDirURL;

$gAssocList{'DefaultPath'} = $kDefaultDBPath;
$gAssocList{'DefaultURL'} = $kDefaultDBURL;

if($dbFullPath =~ /^(.+\/)([\w]+)\/$/) {
	$dbpath = $1;
	$dbDirName = $2;
	$gAssocList{'Path'} = $dbpath;
	if($dbpath ne $kDefaultDBPath) {
		$gAssocList{'CustomLocation'} = 1;
	}#not same as default
}#if

if($dbDirURL =~ /^(.+\/)([\w]+)\/$/) {
	$dbParentURL = $1;
	$dbDirName = $2;
	$gAssocList{'URL'} = $dbParentURL;
	if(!$gAssocList{'CustomLocation'}) {
		if($dbParentURL eq $kDefaultDBURL) {
			$gAssocList{'DefaultLocation'} = 1;
		}#if same  as default
		else {
			$gAssocList{'CustomLocation'} = 1;
		}#else
	}#if
}

# read decription
$gAssocList{'Description'}  = &ReadInfoBaseDescription($dbFullPath);
$templateFile = $kDocDocPagePath . $kDocDBEditTemplate;
&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);

exit 0;
