#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	EditDocPref.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:26	N		Original version
##
##*****************************************************************************



# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "UMProfileAPI.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# Read the input (from the form)
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("type");

# List of all arguments.
@kAllArguments = ("type", "columns", "view");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$type = $userAssocRecord{$kAllArguments[0]};
$columns = $userAssocRecord{$kAllArguments[1]};
$view = $userAssocRecord{$kAllArguments[2]};
$userID = $gAssocList{$kUserIDCookie};
$isDefault = $type eq "default";
if ($isDefault) {
    @values = ();
    $columns = "";
}
else {
    @values = split(",", $columns);
}
# 1 => popup window, 0 => reuse window
$view = ($view eq "default") ? 1 : 0;

$gAssocList{"EDITSUCCESS"} = 1;
$gAssocList{"DefaultChecked"} = ($isDefault ? "Checked" : "");
$gAssocList{"CustomizeChecked"} = ($isDefault ? "" : "Checked");
$gAssocList{"PopupChecked"} = ($view ? "Checked" : "");
$gAssocList{"ReuseChecked"} = ($view ? "" : "Checked");
$gAssocList{"NameSelected"} = "";
$gAssocList{"AppTypeSelected"} = "";
$gAssocList{"AuthorSelected"} = "";
$gAssocList{"ModificationTimeSelected"} = "";
$gAssocList{"CreationTimeSelected"} = "";
$gAssocList{"VersionSelected"} = "";
$gAssocList{"SizeSelected"} = "";
$gAssocList{"DescriptionSelected"} = "";
$gAssocList{"KeywordsSelected"} = "";

$length = $#values + 1;
for ($i = 0; $i < $length; $i++) {
	$gAssocList{$values[$i] . "Selected"} = "SELECTED";
}
local(@record);
$result = &UMGetUserProfile($userID, *record);
if ($result == $errNone) {
    $record[$kUserProfileDocColumnsIndex] = $columns;
	$record[$kUserProfileOtherPrefsIndex] = &UMSetOtherPrefs($record[$kUserProfileOtherPrefsIndex], $kUMDocumentViewIndex, $view);
    $result = &UMSetUserProfile($userID, *record);
}

if ($result == $errNone) {
    $templateFile = $kDocDocPagePath . $kDocEditDocPerfTemplate;
    &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}
else {
	local($errMsg) = "Failed to change the user profile for $userID";
	&LogMsg($errMsg);
	local($errPage) = $kDocErrPagePath . $kErrInternalErrorTemplate;
	$gAssocList{"Body"} =  $errMsg;
	&GenerateHTMLPage($errPage, *gAssocList, $kDocErrPagePath);
}

exit 0;
