#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	EditDocument.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:26	N		Original version
##
##*****************************************************************************

# The Submit button from the Edit Form for document will invoke this cgi.
# This will output a new read only detailed view of the document.

# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "ShowDocuments.pl";
require "ShowFormView.pl";
require "UploadFile.pl";
# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kEditMode);

# Read the input (from the form)
# $lineread = &ReadQueryString();
# above is replaced by upload file version ...

# Create an associative list of (key value) pair
# of the input
local(%userAssocRecord,
      %cgi_cfn,
      %cgi_ct,
      %cgi_sfn);
#&MakeAssociativeList($lineread, *userAssocRecord);
$ret = &GetUploadedFileWithCGIInput(*userAssocRecord, *cgi_cfn, *cgi_ct, *cgi_sfn, $kDocTmpPath);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("docid", "name", "parents");

# List of all arguments.
@kAllArguments = ("docid", "name", "author", "realurl", "size", "apptype", "parents", "keywords", "description", "version", "upfile", "urlorfile");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

local($userID) = $gAssocList{$kUserIDCookie};

$name = $userAssocRecord{$kAllArguments[1]};
$docid = $userAssocRecord{$kAllArguments[0]};
$url = $userAssocRecord{$kAllArguments[3]};
$docLoc = $userAssocRecord{$kAllArguments[11]}; #one of 'file', 'url' or 'desc'
if ($docLoc eq 'desc') {
	$url = '';
	$serverfilename = $cgi_sfn{$kAllArguments[10]};
	unlink($serverfilename);
}
elsif ($docLoc eq 'file') { # Check for upload file or simple url ...
    $clientfilename = &ExtractJustFileName($cgi_cfn{$kAllArguments[10]});
    $serverfilename = $cgi_sfn{$kAllArguments[10]};
    $destfile = &GenerateUniqueFileName($kDocDBRootPath . "docs/", $clientfilename);
    $destfullpath = $kDocDBRootPath . "docs/" . $destfile;
    $url = "\$INFOBASE/" . $destfile;
    #&CopyFile($serverfilename,  $destfullpath);
    #unlink($serverfilename);
	rename($serverfilename,  $destfullpath);
}
else {
	$serverfilename = $cgi_sfn{$kAllArguments[10]};
	unlink($serverfilename);
}

$parents = $userAssocRecord{$kAllArguments[6]};
$parents =~ s/\0/\,/g;

local(@document);
$document[$kDocIDIndex] = $docid;
$document[$kDocNameIndex] = $name;
$document[$kDocAuthorIndex] = $userAssocRecord{$kAllArguments[2]};
$document[$kDocURLIndex] = $url;
$document[$kDocSizeIndex] = $userAssocRecord{$kAllArguments[4]};
$document[$kDocAppTypeIndex] = $userAssocRecord{$kAllArguments[5]};
$document[$kDocCategoryListIndex] = $parents;
$document[$kDocKeywordsIndex] = $userAssocRecord{$kAllArguments[7]};
$document[$kDocDescriptionIndex] = $userAssocRecord{$kAllArguments[8]};
$document[$kDocVersionIndex] = $userAssocRecord{$kAllArguments[9]};

$ie3 = ($ENV{ 'HTTP_USER_AGENT' } =~ /MSIE 3/) ? 1 : 0;
if ($ie3) {
	$gAssocList{"BROWSERIE3"} = 1;
}
$gAssocList{'Parent'} = '';
$gAssocList{'editsuccess'} = 0;
if (!&IsCatDocNameInProperCharSet($name)) {
	$gAssocList{"NAMENOTINCHARSET"} = 1;
	$gAssocList{"EditDocument"} = $name;
	$gAssocList{'editsuccess'} = 0; #needed for JavaScript only for edit saves
    &ShowDocumentForm($docID, *document, 0, *gAssocList);
	exit 0;
}
$result = &OPSetDocument($docid, *document);
$gAssocList{'DocBaseURL'} = $kDocDBRootURL;

if ($result == $errNone) {
    local(@document) = ();
	$gAssocList{'editsuccess'} = 1; #needed for JavaScript only for edit saves
	my(@parentCats) = split($kValueSeperator, $parents);
	$gAssocList{'Parent'} = $parentCats[0];
    &ShowDocumentForm($docid, *document, "", *gAssocList);
    
}
elsif ($result == $errEntryNotFound) {
	&RedirectURL("../cgi-bin/StaleObject.pl?obj=Document");
	exit 0;
}
else {
	$gAssocList{'editsuccess'} = 0; #needed for JavaScript only for edit saves
    &ShowDocumentForm($docID, *document, "Check the Parent value", *gAssocList);
}

exit 0;
