#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	EditGlossaryForm.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:26	N		Original version
##
##*****************************************************************************

# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kEditMode);

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ($kGlossaryDBFields[$kGlossaryTermIndex]);

# List of all arguments.
@kAllArguments = ($kGlossaryDBFields[$kGlossaryTermIndex]);

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$term = $userAssocRecord{$kAllArguments[0]};
@glossary = ();
$result = &OPGetGlossary($term, *glossary, *kGlossaryGetAllFieldsMask);
if($result == 0) {
   	$templateFile = $kDocDocPagePath . $kDocEditGlossaryTemplate;
	$gAssocList{'editsuccess'} = 0; #needed for JavaScript only for edit saves
	$gAssocList{$kGlossaryDBFields[$kGlossaryDefinitionIndex]} = $glossary[$kGlossaryDefinitionIndex];
	$gAssocList{$kGlossaryDBFields[$kGlossaryTermIndex]} = $glossary[$kGlossaryTermIndex];
	$gAssocList{"OrigTerm"} = $glossary[$kGlossaryTermIndex];
	&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}
else {
	if($result != $errNone) { # handle error
		&RedirectURL("../cgi-bin/StaleObject.pl?obj=Glossary%20Term");
		exit 0;
	}
}

exit 0;
