#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	EditUser.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:26	N		Original version
##
##*****************************************************************************

# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "ShowUsersUtils.pl";
require "UMProfileAPI.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kAdminMode);

# Read the input (from the form)
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("userid", "name", "email", "type", "groups");

# List of all arguments.
@kAllArguments = ("userid", "name", "email", "type", "groups");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);


$userid = $userAssocRecord{$kAllArguments[0]};
$name = $userAssocRecord{$kAllArguments[1]};
$email =  $userAssocRecord{$kAllArguments[2]};
$type =  $userAssocRecord{$kAllArguments[3]};
$groups =  $userAssocRecord{$kAllArguments[4]};

local(@olduserRecord);
$result = &UMGetUser($userid, *olduserRecord);
if ($result == $errNone) {

    local(@oldgroups) = split($kValueSeperator, $olduserRecord[$kUserGroupListIndex]);
    local(@newgroups) = split($kValueSeperator, $groups);

    # compute the add/remove groups ...
    local(@removegroups, @addgroups);
    foreach $group (@oldgroups) {
	if (!&MemberOf($group, *newgroups)) {
	    push(@removegroups, $group);
	}
    }
    foreach $group (@newgroups) {
	if (!&MemberOf($group, *oldgroups)) {
	    push(@addgroups, $group);
	}
    }

    local(@userRecord);
    $userRecord[$kUserUserIDIndex] = $userid;
    $userRecord[$kUserTypeIndex] = $type;
    $userRecord[$kUserGroupListIndex] = $groups;
    
    local(@userProfileRecord);
    $userProfileRecord[$kUserProfileUserIDIndex] = $userid;
    $userProfileRecord[$kUserProfileNameIndex] = $name;
    $userProfileRecord[$kUserProfileEmailIndex] = $email;
    
    $result = &UMUpdateUser($userid, *userRecord);
    $result = $result || &UMSetUserProfile($userid, *userProfileRecord);

    # remove the user from the old groups ...
    foreach $group (@removegroups) {
		&UMRemoveUserFromGroup($group, $userid, 0, 1);
    }
    # add the user to the new groups ...
    foreach $group (@addgroups) {
		&UMAddUserToGroup($group, $userid, 0, 1);
    }
    &ShowUsers(*gAssocList);
}
else {
	&RedirectURL("../cgi-bin/StaleObject.pl?obj=User");
	exit 0;
    local($errPage) = $kDocErrPagePath . $kErrInternalErrorTemplate;	
    $gAssocList{"Body"} =  "User: $userid not found!";
    &GenerateHTMLPage($errPage, *gAssocList, $kDocErrPagePath);
}


exit 0;
