#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	EditUserForm.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:26	N		Original version
##
##*****************************************************************************

# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "UMProfileAPI.pl";
require "ShowUsersUtils.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kAdminMode);

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("UserID");

# List of all arguments.
@kAllArguments = ("UserID");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$userID = $userAssocRecord{$kAllArguments[0]};
local(@uProfile, @uRecord) = ();

if ($userID eq $kAdminUserID) {
	$gAssocList{"EditUserID"} = $userID;
	$gAssocList{"EDITERROR"} = 1;
	$gAssocList{"errAdminUserEdit"} = 1;
	&ShowUsers(*gAssocList);
	exit 0;
}

$result = &UMGetUser($userID, *uRecord);
$result = $result || &UMGetUserProfile($userID, *uProfile);
if ($result == 0) {
    $gAssocList{"UserID"} = $userID;
    $gAssocList{"Name"} = $uProfile[$kUserProfileNameIndex];
    $gAssocList{"EMail"} = $uProfile[$kUserProfileEmailIndex];

    $type = $uRecord[$kUserTypeIndex];
    $gAssocList{"${type}Selected"} = 'SELECTED';

    local(@groups);
    @groups = split($kValueSeperator, $uRecord[$kUserGroupListIndex]);

    local(@allgroups) = ();
    &UMGetAllGroupNames(*allgroups);
    
    my($group);
    my($grouptext) = "";
    foreach $group (@allgroups) {
		$select = &MemberOf($group, *groups)  ? 'SELECTED' : '';
		$grouptext .= "<OPTION ${select}>$group\n";
    }
	
    $gAssocList{"Groups"} = $grouptext;    
    $templateFile = $kDocDocPagePath . $kDocEditUserTemplate;
    &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}
else {
	&RedirectURL("../cgi-bin/StaleObject.pl?obj=User");
	exit 0;
}

exit 0;
