#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	EditWhatsNewPerfForm.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:26	N		Original version
##
##*****************************************************************************



# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "UMProfileAPI.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

$lineread = &ReadQueryString();

$templateFile = $kDocDocPagePath . $kDocEditWhatsNewTemplate;
$gAssocList{"DefaultChecked"} = "";
$gAssocList{"CustomizeChecked"} = "";
$gAssocList{"NameSelected"} = "";
$gAssocList{"AppTypeSelected"} = "";
$gAssocList{"AuthorSelected"} = "";
$gAssocList{"ModificationTimeSelected"} = "";
$gAssocList{"CreationTimeSelected"} = "";
$gAssocList{"VersionSelected"} = "";
$gAssocList{"SizeSelected"} = "";
$gAssocList{"DescriptionSelected"} = "";
$gAssocList{"KeywordsSelected"} = "";

$userID = $gAssocList{$kUserIDCookie};
my($whatsNew) = &UMGetUsersWhatsNewHours($userID);

if (!$whatsNew) {
    $whatsNew = $kDefaultWhatsNewHours;
}

my($hours) = 0;
my($days) = 0;
if ($whatsNew >= 24) {
	$hours = $whatsNew % 24;
	$days = ($whatsNew - $hours)/24;
}
else {
	$hours = $whatsNew;
}

$gAssocList{"Days"} = $days;
$gAssocList{"Hours"} = $hours;

&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);

exit 0;
