#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	FindCategory.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:00	N		Original version
##
##*****************************************************************************

# This will be invoked from the Find form for a category.
# This cgi will take the criteria and display the resultant records.


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "OPFind.pl";
require "Listing.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("namecriteria", "descriptioncriteria");

# List of all arguments.
@kAllArguments = ("name", "namecriteria", "description", "descriptioncriteria");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);


$templateFile = $kDocDocPagePath . $kDocFindCategoryResultTemplate;
my($totalCells, $numCellsPerRow) = (0, 2);
@categoryList = ();
@category = ();
$category[$kCategoryNameIndex] = $userAssocRecord{$kAllArguments[0]};
$category[$kCategoryDescIndex] = $userAssocRecord{$kAllArguments[2]};

@criteria = ();
$criteria[$kCategoryNameIndex] = &GetStringCriteria($userAssocRecord{$kAllArguments[1]});
$criteria[$kCategoryDescIndex] = &GetStringCriteria($userAssocRecord{$kAllArguments[3]});

$result = &OPFindCategory(*category, *criteria, *categoryList);

if($result == 0) {
	my($count) = $#categoryList + 1;
	if ($count == 0) {
		$gAssocList{"Result"} = "!!! No Match Found !!!";
		$gAssocList{"NoCategories"} = "";
		$gAssocList{"TABLEEXISTS"} = 0;
	}
	else {
		$gAssocList{"Result"} = "";
		$totalCells = &GenCategoryTableCells(*categoryList, *gAssocList);
		$gAssocList{"NoCategories"} = "";
		$gAssocList{"TABLEEXISTS"} = 1;
	}
	&GenerateHTMLFromTemplate($templateFile, $totalCells, $numCellsPerRow, *gAssocList, $kDocDocPagePath);
}
else {
	my($errPage) = $kDocErrPagePath . $kErrInternalErrorTemplate;
	$gAssocList{"Body"} = "Find Category failed!";
	&GenerateHTMLPage($errPage, *gAssocList, $kDocErrPagePath);
}

exit 0;
