#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	FindDocumentForm.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:05	N		Original version
##
##*****************************************************************************

# The Find Category button will invoke this cgi. This will output a form for the
# user to specify the find criteria for categories.


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "DocUtils.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ();
# List of all arguments.
@kAllArguments = ("type");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$templateFile = $kDocDocPagePath . $kDocFindDocumentTemplate;
$type = $userAssocRecord{$kAllArguments[0]};
if (!defined($type) || $type eq "qualified") {
    $gAssocList{'QualifiedSearch'} = 1;
    $gAssocList{'IsQualified'} = 'yes';
    $gAssocList{'FindCGIName'} = 'FindDocument';
}
else {
    $gAssocList{'SimpleSearch'} = 1;
    $gAssocList{'IsQualified'} = 'no';    
    $gAssocList{'FindCGIName'} = 'SimpleFindDocument';
}
$parentsHTMLString = "";
@givenParents = (); #no given parents, get all possible parents
$parentsHTMLString = &GetDocumentParentSelectList(*givenParents);
$gAssocList{"CategorySelection"} = $parentsHTMLString;

&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);

exit 0;
