#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	AddCategory.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:26	N		Original version
##
##*****************************************************************************

# The Add Category form will invoke this cgi. This will add the category with specified field and 
# indicate to the user of add was successful.


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";
%DEFAULTMIMETYPES = (                # file-type to content-type mapping table.
    '','application/unknown',        # this is the default
    'html','text/html',
    'htm','text/html',
    'doc','application/vnd.ms-word',
    'xls','application/vnd.ms-excel',
    'jpg','image/jpeg',
    'gif','image/gif',
    'zip','application/zip',
    'wav','audio/x-wav',
    'exe','application/dos-executable'
) ;

sub ReadMIMETypes {
	my($configFile, $assoc) = @_; #$assoc is passed in as a reference
	if (!open(CONFIGFILE, "<$configFile")) {
		&LogFileOpenFailMsg($configFile);
		&LogMsg("ReadMIMETypes::MIME Types file could not be opened !!!");
	}
	else {
		&GetReadLockOnFile("CONFIGFILE") || &LogMsg("ReadSpecifiedConfigFile:: failed on read lock on file $configFile: $!");
		my($line);
		%$assoc = (); #$assoc is passed in as a reference
		while (!eof(CONFIGFILE)) {
			$line = <CONFIGFILE>;
			chop($line);
			if ($line && ($line !~ /^[\s]*$/) && ($line !~ /^[\s]*#/) ) { #not a comment line
				my(@pairs) = ();
				if($line =~ /^[\s]*([\S]+)[\s]+([\S]+)[\s]*(.*)$/) { #remove preceding/following spaces
					$pairs[0] = $2;
					$pairs[1] = $1;
					$assoc->{$pairs[0]} = $pairs[1];
					my($moreExt) = $3; # can have multiple extensions on same line
					# get remaining extensions
					while($moreExt =~ /^[\s]*([\S]+)[\s]*(.*)$/) {
						$assoc->{$1} = $pairs[1];
						$moreExt = $2;
					}# while
				}#if
			}#if comment line
		}#while
		close(CONFIGFILE);
		&UnlockFile("CONFIGFILE") || &LogMsg("ReadSpecifiedConfigFile:: failed on unlock on file $configFile: $!");
	}# else
}# ReadMIMETypes


sub HTTPHeader {
    local($type) = @_ ;
    print "Content-type: $type\n\n" if ($type ne '') ;
}#HTTPHeader

sub GetDocument {
	my($filename) = @_;
	binmode(STDOUT) ;
	if ($filename && open(F,"<$filename"))  {
		binmode(F) ;
		my($ctype) = "" ;
		if ($filename=~/\.([^.]+)$/) {
			($ctype=$1) =~ tr/[A-Z]/[a-z]/ ;
		}
		my(%mimeTypes) = ();
		&ReadMIMETypes($kMimeTypesFile, \%mimeTypes);
		my($doctype);
		if(defined $mimeTypes{$ctype}) {
			$doctype = $mimeTypes{$ctype};
		}
		elsif (defined $DEFAULTMIMETYPES{$ctype}) {
			$doctype = $DEFAULTMIMETYPES{$ctype};
		}
		else {
			$doctype = $DEFAULTMIMETYPES{''};
		}
		&HTTPHeader( $doctype, $fsize) ;
		print while (<F>) ;
		close(F) ;
	} 
	else  {
		&LogMsg("Can't open $filename\n") ;
		print "Content-type: text/html\n\n" ;
		print "<BODY><h1>HTTP/1.0 404 Object Not Found</h1></BODY></html>\n" ;
	}

}#GetDocument

# --------------------------------------------------------------------------------
# Execute ...
#

# Read the input (from the form)
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ();

# List of all arguments.
@kAllArguments = ("docName");

my($PathInfo) = $ENV{ 'PATH_INFO' };
$docName = '';
if($ENV{ 'QUERY_STRING' } && !($ENV{ 'QUERY_STRING' } eq '')) {
		$docName = $userAssocRecord{$kAllArguments[0]};
}
else {
	if($PathInfo =~ /^.*\/([^\/]+)$/) {
		$docName = $1;
	}
}
$gAssocList{"docName"} = $docName;
$fullDocPath = $kDocUsrDocPath . $docName;
&GetDocument($fullDocPath);
exit 0;

