#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	Login.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/28/96	13:17	N		Original version
##
##*****************************************************************************

# This cgi will display a Login page

# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "SessionUtils.pl";
require "CGIUtility.pl";
#require "LogMsg.pl";
#require "BaseDocGlobals.pl";

# --------------------------------------------------------------------------------
#
 sub getUserID {
       my($name) = $ENV{'REMOTE_USER'};
       return $name;
 }

$kDocLoginAlreadyTemplate = "U54.htm";
# --------------------------------------------------------------------------------
# Execute ...
#
#&LogToFileEnable($kErrorLogFile);

# First check if the user is already logged into an Infobase
$result = &IsValidSession();
if ($result) {
	$gAssocList{'INFOBASE'} = &ReadInfoBaseName($kDocDBRootPath);
	$gAssocList{'USERID'} = $gAssocList{$kUserIDCookie};
	$templateFile = $kDocDocPagePath . $kDocLoginAlreadyTemplate;
	&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
	exit 0;
}

# setup test cookie ...
$gSessionCookie = "Test=1;path=/;"; 

# Go for login
$userid = "";
my($dbname);

# check for previous login cookie ...
my(@values) = &GetCookies($kPreviousLoginCookie);

if ($#values > 0) {
#	$userid = $values[0];
	$dbname = $values[1];# get last logged into infobase
}

%dbassoc = ();
%dburl = ();

$userid = &getUserID();

if(!$userid) {
      $templateFile = $kDocErrPagePath . $kErrInvalidUserTemplate;
      &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
      exit 0;
}#end if
$gAssocList{'USERID'} = $userid;

#new login
	&ReadDatabaseNames(\%dbassoc, \%dburl);
	$dbselect = &GetDBOptionList(*dbassoc);
	$gAssocList{'DBSELECTIONS'} = $dbselect;
	$gAssocList{'DB'} = 1;

$ie3 = ($ENV{ 'HTTP_USER_AGENT' } =~ /MSIE 3/) ? 1 : 0;
if ($ie3) {
	$gAssocList{"BROWSERIE3"} = 1;
}

	$gAssocList{"CLOSE"} = "false";
	$templateFile = $kDocDocPagePath . $kDocLoginTemplate;
	&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);


exit 0;
