#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	Login.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/28/96	13:17	N		Original version
##
##*****************************************************************************

# This cgi will display a Login page


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "UMAPI.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

$query = &ReadQueryString();

# reset the cookie
$gSessionCookie = "${kLoadedSessionIDCookie}=;";
#add path to cookie
my($cookiePath) = $ENV{ 'SCRIPT_NAME' };
if($cookiePath =~ /(.*)\/[\w\-]+\/[\w\-\.]+/) {
	$cookiePath =~ s/(.*)\/[\w\-]+\/[\w\-\.]+/$1\//; #remove cgi-bin/Logout.pl from URL
}
else {
	$cookiePath = '/';
}
$gSessionCookie = $gSessionCookie . 'path=' . $cookiePath . ';';

# Terminate user's session
&UMEndSession($gAssocList{$kSessionIDCookie}) if $gAssocList{$kSessionIDCookie}; 

$userID = $gAssocList{$kUserIDCookie};
if ($userID eq $kSpecialGuestUser) {  # if special user, then no login prompt
	my($templateFile) = $kDocDocPagePath . $kDocCloseWindowTemplate;
	&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}
elsif ($gAssocList{$kAnonymousUserCookie}) {
	my($url) = $gAssocList{$kLogoutURLCookie};
	my($close) = $gAssocList{$kAnonymousLogoutCloseCookie};
	$gAssocList{"CLOSE"} = ($close) ? "true" : "false";
	$gAssocList{"URL"} = defined($url) ? $url : "";
	$templateFile = $kDocDocPagePath . ((!$close && !$url) ? $kDocAnonymousLogoutTemplate : $kDocAnonymousLogoutURLTemplate);
	&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}
else {
	$userid = "";

	my($dbname);
	
    # check for previous login cookie ...
	my(@values) = &GetCookies($kPreviousLoginCookie);
	if ($#values > 0) {
		$userid = $values[0];
		$dbname = $values[1];
	}

	%dbassoc = ();
	%dburl = ();
	&ReadDatabaseNames(\%dbassoc, \%dburl);
	$dbselect = &GetDBOptionList(*dbassoc, $dbname);
	$gAssocList{'DBSELECTIONS'} = $dbselect;
	$gAssocList{'DB'} = 1;    
	$gAssocList{'USERID'} = $userid;

	$gAssocList{"CLOSE"} = "true";
	$templateFile = $kDocDocPagePath . $kDocLoginTemplate;
	&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}
exit 0;
