#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	OrphanDocument.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:27	N		Original version
##
##*****************************************************************************

# This will remove the document, given its key from the database.
# This cgi can be invoked from the detailed view of a document.

# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "ShowDocuments.pl";
require "ShowCategories.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kEditMode);

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("DocID", "cmdtype");

# List of all arguments.
@kAllArguments = ("DocID", "Category", "cats", "cmdtype");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$docID = $userAssocRecord{$kAllArguments[0]};
$category = $userAssocRecord{$kAllArguments[1]};
$plist = $userAssocRecord{$kAllArguments[2]};
$type = $userAssocRecord{$kAllArguments[3]};

my(@record) = ();
$result = &OPGetDocument($docID, \@record);
if ($result == $errEntryNotFound) {
	&RedirectURL("../cgi-bin/StaleObject.pl?obj=Document");
	exit 0;
}

if ($type eq "all") {
	$result = &OPRemoveDocument($docID);
}
else {
	my(@removedParents) = split($kValueSeperator, $plist);
	my($count) = $#removedParents + 1;
	my($i) = 0;
	for (; $i < $count;) {
		my($parent) = $removedParents[$i++];
		&OPRemoveDocumentFromCategory($docID, $parent, 1);
	}
}
if($result != 0) {
    $gAssocList{"REMOVEERROR"} = 1;
    $gAssocList{"RemoveDocument"} = "DocID: $docID";
	if ($result == $errEntryNotFound) {
		$gAssocList{"errEntryNotFound"} = 1;
	}
}
my($path);
$uid = $gAssocList{$kUserIDCookie};

$gAssocList{"InfoBase"} = &ReadInfoBaseName($kDocDBRootPath);

if (!defined($category)) {
    $category = $kRootCategoryID;
}
my(@categoryRecord) = ();
$result = &OPGetCategory($category, \@categoryRecord);
if ($result != $errNone) {
	$category = $kRootCategoryID;
	&OPGetCategory($category, \@categoryRecord);
}
if ($categoryRecord[$kCategoryChildListIndex]) {
	&ShowCategories($category, $edit, *gAssocList);
}
else {
    &ShowDocuments($category, $edit, *gAssocList, $path, $uid);
}

exit 0;
