#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	RemoveCategoryConfirm.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:27	N		Original version
##
##*****************************************************************************

# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "ShowCategories.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kEditMode);

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("Name");

# List of all arguments.
@kAllArguments = ("Name");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$name = $userAssocRecord{$kAllArguments[0]};
my(@category) = ();
$result = &OPGetCategory($name, \@category);
if($result == 0) {
	$gAssocList{"Name"} = $category[$kCategoryNameIndex];
	$gAssocList{"ID"} = $name;
	local(@list) = &SListUnmake($category[$kCategoryChildListIndex], $kValueSeperator);
    local($catcount) = $#list + 1;
	@list = &SListUnmake($category[$kCategoryDocIDListIndex], $kValueSeperator);
	local($doccount) = $#list + 1;
	if ($catcount > 0 && $doccount > 0) {
		$gAssocList{"BOTHCATDOC"} = 1;
	}
	else {
		if ($catcount > 0) {
			$gAssocList{"ONLYCATERGORIES"} = 1;
		}
		else {
			if ($doccount > 0) {
				$gAssocList{"ONLYDOCUMENTS"} = 1;
			}
		}
	}
    local($templateFile) =  $kDocDocPagePath . $kDocRemoveCategoryTemplate;
    &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}
else {
    $gAssocList{"REMOVEERROR"} = 1;
	$gAssocList{"RemoveCategory"} = $name;
    $parent = $kRootCategoryID;
    &ShowCategories($parent, $edit, *gAssocList);
}

exit 0;
