#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	RemoveUser.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:27	N		Original version
##
##*****************************************************************************

# This will remove the user, given its key from the database.

# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "ShowUsersUtils.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kAdminMode);

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("UserID", "Confirm");

# List of all arguments.
@kAllArguments = ("UserID", "Confirm");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$result = $errNone;
$userID = $userAssocRecord{$kAllArguments[0]};

$currentUserID = $gAssocList{$kUserIDCookie};

if($userID eq $kAdminUserID) { # do not allow to delete the system admin
	$gAssocList{"errAdminUser"} = 1;
	$result = $errOPFailed;
} elsif ($userID eq $currentUserID) { # do not allow to delete the current user
	$gAssocList{"errCurrentUser"} = 1;
	$result = $errOPFailed;
} else { # else okay to delete user
	$removeit = ($userAssocRecord{$kAllArguments[1]} eq "yes");
	if ($removeit) {
		$result = &UMRemoveUser($userID);
	}
	else {
		$result = $errNone;
	}
}# else okay to delete user

if($result != $errNone) {
    $gAssocList{"REMOVEERROR"} = 1;
    $gAssocList{"RemoveUserID"} = $userID;
	if ($result == $errEntryNotFound) {
		&RedirectURL("../cgi-bin/StaleObject.pl?obj=User");
		exit 0;		
		$gAssocList{"errEntryNotFound"} = 1;
	}
}
&ShowUsers(*gAssocList);

exit 0;
