#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	ShowCategory.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:24	N		Original version
##
##*****************************************************************************

# This will show the detailed view of a category, given its key.
# This cgi can be invoked from any view showing a category reference.


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "DocUtils.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("ID");

# List of all arguments.
@kAllArguments = ("ID");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$id = $userAssocRecord{$kAllArguments[0]};
@category = ();
$result = &OPGetCategory($id, *category, @kCatGetAllFieldsMask);
if($result == 0) {
	$templateFile = $kDocDocPagePath . $kDocCategoryTemplate;
	$category[$kCategoryCreationTimeIndex] = &GetTimeFormatted($category[$kCategoryCreationTimeIndex]);
	$category[$kCategoryModificationTimeIndex] = &GetTimeFormatted($category[$kCategoryModificationTimeIndex]);
	&FillInAssocList(*kCategoryDBFields, *category, *gAssocList);

	&OPGetCategory($category[$kCategoryParentIndex], \@record);
	$gAssocList{$kCategoryDBFields[$kCategoryParentIndex]} = $record[$kCategoryNameIndex];

	$gAssocList{"Path"} = &GetCategoryPath($id, 0);
	&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}
else {
	&RedirectURL("../cgi-bin/StaleObject.pl?obj=Category");
	exit 0;
	local($errPage) = $kDocErrPagePath . $kErrInternalErrorTemplate;
	$gAssocList{"Body"} = "Category ${id} not found!";
	&GenerateHTMLPage($errPage, *gAssocList, $kDocErrPagePath);
}

exit 0;
