#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	TopLevel.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:25	N		Original version
##
##*****************************************************************************

# This cgi will list global commands


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "UMSessionAPI.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ();

# List of all arguments.
@kAllArguments = ("Name", "Expand");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$name = $userAssocRecord{$kAllArguments[0]};
$expand = $userAssocRecord{$kAllArguments[1]};

if (!defined($expand)) {
	$expand = 1;
}
else {
	$expand = eval($expand);
}
$sessionID = $gAssocList{$kSessionIDCookie};
$bodyURL = "";
local($menuControl) = 0;
local($mode) = $kReadOnlyMode;
&UMGetMenuControlAndUserMode($sessionID, *menuControl, *mode);
if (defined($name)) {
    if ($name eq "Browse") {
		$menuControl = ($expand) ? ($menuControl & ~$kMenuControlBrowse) : ($menuControl | $kMenuControlBrowse);
    }
    elsif ($name eq "MoreBrowse") {
		$menuControl = ($expand) ? ($menuControl & ~$kMenuControlMoreBrowse) : ($menuControl | $kMenuControlMoreBrowse);
    }
    elsif ($name eq "Admin") {
		$menuControl = ($expand) ? ($menuControl & ~$kMenuControlAdmin) : ($menuControl | $kMenuControlAdmin);
		if ($expand) {
			$menuControl = ($menuControl | $kMenuControlAllIB);
		#	$bodyURL = "../cgi-bin/ShowUsers.pl";
			$bodyURL = "../cgi-bin/ShowInfobases.pl";
		}
	}
    elsif ($name eq "AllIB") {
		$menuControl = ($expand) ? ($menuControl & ~$kMenuControlAllIB) : ($menuControl | $kMenuControlAllIB);
		if ($expand) {
			$menuControl = ($menuControl | $kMenuControlAdmin);
			$bodyURL = "../cgi-bin/ShowInfobases.pl";
		}
    }
    elsif ($name eq "Modifications") {
		$menuControl = ($expand) ? ($menuControl & ~$kMenuControlModifications) : ($menuControl | $kMenuControlModifications);
    }
    elsif ($name eq "Preferences") {
		$menuControl = ($expand) ? ($menuControl & ~$kMenuControlPreferences) : ($menuControl | $kMenuControlPreferences);
    }
    elsif ($name eq "UserMode") {
		if($expand) {
			$menuControl = ($menuControl & ~$kMenuControlUserMode);
			$bodyURL = "../cgi-bin/TopLevel.pl";
		}
		else {
			$menuControl = ($menuControl | $kMenuControlUserMode);
		#	$bodyURL = ($menuControl & $kMenuControlAllIB) ? ("../cgi-bin/ShowUsers.pl") :("../cgi-bin/ShowInfobases.pl");
			$bodyURL = "../cgi-bin/ShowInfobases.pl";
		}
		
    }
    &UMSetMenuControl($sessionID, $menuControl);
}

$gAssocList{($menuControl & $kMenuControlBrowse) ? "BrowseCollapsed" : "Browse"} = 1;
$gAssocList{($menuControl & $kMenuControlMoreBrowse) ? "MoreBrowseCollapsed" : "MoreBrowse"} = 1;
$gAssocList{($menuControl & $kMenuControlModifications) ? "ModificationsCollapsed" : "Modifications"} = 1;
$gAssocList{($menuControl & $kMenuControlPreferences) ? "PreferencesCollapsed" : "Preferences"} = 1;
$gAssocList{($menuControl & $kMenuControlUserMode) ? "AdminOperations" : "UserOperations"} = 1;
$gAssocList{($menuControl & $kMenuControlAdmin) ? "AdminCollapsed" : "Admin"} = 1;
$gAssocList{($menuControl & $kMenuControlAllIB) ? "AllInfobaseCollapsed" : "AllInfobase"} = 1;
if (($mode & $kEditMode) == $kEditMode) {
	$gAssocList{"EditMode"} = 1;
}
if (($mode & $kSuperAdminMode) == $kSuperAdminMode) {
	$gAssocList{"SuperAdminMode"} = 1;
	$gAssocList{"AdminMode"} = 1;
}
elsif (($mode & $kAdminMode) == $kAdminMode) {
	$gAssocList{"AdminMode"} = 1;
}
else {
	$gAssocList{"NonAdminMode"} = 1;
}

# control anonymous users
if (!$gAssocList{$kAnonymousUserCookie}) {
	$gAssocList{"SHOWPREFERANCE"} = 1;
}

# get the infobase name 
$ibname = &ReadInfoBaseName($kDocDBRootPath);
$gAssocList{"InfoBase"} = $ibname; 
$gAssocList{"EscInfoBase"} = &EncodeForURL($ibname);
$gAssocList{"BODYURL"} = $bodyURL;

$ie3 = ($ENV{ 'HTTP_USER_AGENT' } =~ /MSIE 3/) ? 1 : 0;
if (!$ie3) {
	$gAssocList{"NOTBROWSERIE3"} = 1;
}

$templateFile = $kDocDocPagePath . $kDocCommandsTemplate;
&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);

exit 0;

