#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	ShowDocument.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:25	N		Original version
##
##*****************************************************************************

# This will show the detailed view of a document, given its key.
# This cgi can be invoked from any view showing a document reference.


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "DocUtils.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ("DocID");

# List of all arguments.
@kAllArguments = ("DocID");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$docID = $userAssocRecord{$kAllArguments[0]};
@document = ();
$result = &OPGetDocument($docID, *document, @kDocGetAllFieldsMask);
if($result == 0) {
	$templateFile = $kDocDocPagePath . $kDocumentTemplate;
	$document[$kDocCreationTimeIndex] = &GetTimeFormatted($document[$kDocCreationTimeIndex]);
	$document[$kDocModificationTimeIndex] = &GetTimeFormatted($document[$kDocModificationTimeIndex]);
	&FillInAssocList(*kDocumentDBFields, *document, *gAssocList);
	my(@parents) = &SListUnmake($document[$kDocCategoryListIndex], $kValueSeperator);
	my(@names) = ();
	&OPGetCategoryNamesFromIDs(\@parents, \@names);
    for ($i = 0; $i <= $#parents; $i++) {
		$names[$i] = &GetCategoryPath($parents[$i], 1, 1);
    }
	$gAssocList{$kDocumentDBFields[$kDocCategoryListIndex]} = join(", ", @names);

	$gAssocList{"Path"} = &GetCategoryPath($parents[0], 1);
	&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}
else {
	&RedirectURL("../cgi-bin/StaleObject.pl?obj=Document");
	exit 0;
	local($errPage) = $kDocErrPagePath . $kErrInternalErrorTemplate;	
	$gAssocList{"Body"} = "Document: ${docID} not found!";
	&GenerateHTMLPage($errPage, *gAssocList, $kDocErrPagePath);
}

exit 0;
