#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	ShowIndex.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:17	N		Original version
##
##*****************************************************************************

# This cgi will list all the categories and documents
# in a sorted linear view for the Index.


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "UMProfileAPI.pl";
require "Listing.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

sub GetDocumentsListing
{
    local($userID, *assocList) = @_;
    my($result);
 	my($count) = 0;
	local(@db, @docs);
    $result = &DBOpen($kDocumentDB, $kDocDBPath, $kDBReadAccess, *db);
    if ($result == $errNone) {
	    local(@document) = ();
	    $result = &DBReadFirstRecord(*db, *document);
	    while (!$result) {
	        push(@docs, &SListMake(*document, $kFieldSeperator));
	        $result = &DBReadNextRecord(*db, *document);
	    }
	    $count = $#docs + 1;
	    if ($count) {
			local(%newAssocList) = ();
	        local(@sortedDocs) = &SortRecordsOnField(*docs, $kDocNameIndex + 1);
	        my($columnCount) = &PrepareDocColumnsForListing($userID, *newAssocList);
	        my($whatsNewTime) = &UMComputeUsersWhatsNewTime($userID);
			my(@alphaList) = ( 'A-F', 'G-L', 'M-P', 'Q-T', 'U-Z', '^A-Z');#last entry covers non-alphabets
			my($i);
			for ($i=1; $i <= 6; $i++) {
				my($data) = "None";
				my($cnt) = &AddDocumentsToTableCells(*sortedDocs, $count, 0, *newAssocList, $whatsNewTime, $alphaList[$i-1]);
				if ($cnt) {
					$data = &ProcessHTMLFromTemplate($kDocDocPagePath . "DocTable.htm", $columnCount*$cnt, $columnCount, 
													 *newAssocList, $kDocDocPagePath);
				}
				$gAssocList{"DocumentList" . $i} = $data;
			}
			$assocList{'DOCTABLEEXISTS'} = 1;
		    $assocList{'NoDocuments'} = "";
		}#if docs present
		else {
		    $assocList{'NoDocuments'} = $docsdata;
		}
       &DBClose(*db);
    }
	return $count;
}

# --------------------------------------------------------------------------------

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ();

# List of all arguments.
@kAllArguments = ();

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

# First get the userid ...
$userID = $gAssocList{$kUserIDCookie};

$templateFile = $kDocDocPagePath . $kDocIndexTemplate;
@categoryList = ();
$gAssocList{'EmptyInfobase'} = 1;
$result = &OPGetAllCategories(*categoryList);
if ($result) {
    my($count) = $#categoryList + 1;
    local($data) = "";
    if ($count == 1) { #Main category always exists
	    $gAssocList{"CategoryList"} = "";
    }
    else {
		local(%newAssocList) = ();
		my($catCount) = &GenCategoryTableCells(*categoryList, *newAssocList);
		$gAssocList{'EmptyInfobase'} = 0;
		$gAssocList{'NonEmptyInfobase'} = 1;
		$data = &ProcessHTMLFromTemplate($kDocDocPagePath . "CategoryTable.htm", $catCount, 2, 
										 *newAssocList, $kDocDocPagePath);
		$gAssocList{"CategoryList"} = $data;
	}
	my($docsExist) = &GetDocumentsListing($userID, *gAssocList);
	if($docsExist) {
		$gAssocList{'EmptyInfobase'} = 0;
		$gAssocList{'NonEmptyInfobase'} = 1;
		$gAssocList{'DOCTABLEEXISTS'} = 1;
		$gAssocList{'NoDocuments'} = 0;
	}#if
	else {
		$gAssocList{'NoDocuments'} = 1;
	}
    &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}
else {
    local($errMsg) = "Failed to get list of categories";
    &LogMsg($errMsg);
    local($errPage) = $kDocErrPagePath . $kErrInternalErrorTemplate;
    $gAssocList{"Body"} =  $errMsg;
    &GenerateHTMLPage($errPage, *gAssocList, $kDocErrPagePath);
}
exit 0;
