#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	ShowInfoBases.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	02/14/97	13:25	N		Original version
##
##*****************************************************************************

# This cgi will list all the categories for the Top Level view
# in a Table form.
# This can be invoked from Welcome Page.


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

# --------------------------------------------------------------------------------
#
sub ShowInfoBases
{
	my($assocList) = @_; # reference parameter
	my($totalCells, $numCellsPerRow) = (1, 1);

	my($templateFile) = $kDocDocPagePath . $kDocDBListTemplate;
	my(%dbpathassoc) = ();
	my(%dburlassoc) = ();
	&ReadDatabaseNames(\%dbpathassoc, \%dburlassoc);
	my(@names) = keys(%dbpathassoc);
    my($count) = $#names + 1;
    if ($count == 0) {
      $assocList{"NoInfoBases"} = "No InfoBases";
    }
    else {
      $assocList{"TABLEEXISTS"} = 1;
      $assocList{"NoInfoBases"} = "";
      $totalCells = &GenInfoBaseTableCells(\@names, \%assocList);
      $numCellsPerRow = 2;
    }
    &GenerateHTMLFromTemplate($templateFile, $totalCells, $numCellsPerRow, *assocList, $kDocDocPagePath);
}

# The following routine will generate an associated list to represent
# each category in the table view as a cell.
# Each cell contains a Title string and its link.
# Therefore, 2 items needs to be generated per cell in the 2nd parameter.
# The %assocList is used to return the values with keywords using the cell#:
# eg. Title0link = /tmp/p1.htm; Title0 = Presentations
sub GenInfoBaseTableCells
{	
	my($infoBaseList, $assocList) = @_;
	my(@sortedList) = sort  { lc($a) cmp lc($b) } @$infoBaseList;
	my($cellCount, $count) = (0, $#sortedList + 1);
	for ($cellCount = 0; $cellCount < $count; $i++) {
		my($name) = $sortedList[$cellCount];
		my(@keyList) = ("EscapedTitle${cellCount}", "Title${cellCount}");
		$cellCount++; # only non root categories are to be indexed
		my($encodedName) = &EncodeForURL($name);
		$assocList->{$keyList[0]} = $encodedName;
		$assocList->{$keyList[1]} = $name;
	}#for
	return $count;
}

# --------------------------------------------------------------------------------
# Execute ...
#

# verify user acccess first
&VerifyUserAccess($kSuperAdminMode);

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ();

# List of all arguments.
@kAllArguments = ();

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

&ShowInfoBases(\%gAssocList);

exit 0;
