#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	SimpleFindDocument.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996, 1997.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	03/31/97	13:05	Thyag	Original version
##
##*****************************************************************************

# This will be invoked from the Find form for documents.
# This cgi will take the criteria and display the resultant records.


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "OPFind.pl";
require "Listing.pl";
require "Search.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# Read from stdin
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ();
#@kMandatoryArguments = ("query");

# List of all arguments.
@kAllArguments = ("query");

# Check if all the mandatory arguments are specified
@missingArguments = ();
&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$query = $userAssocRecord{$kAllArguments[0]};

my($userID) = $gAssocList{$kUserIDCookie};

$query =~ tr/\t/ /;  #replace tabs by spaces
$query = join(' ', split(' ', $query));
$result = 0;
local(@docs) = ();
if ($query) {
    my(@docWeights);
    $result = &SEFindMatchedDocs($query, \@docs, \@docWeights);
}
if ($result == 1) {
    &ShowFindResult(*gAssocList, *docs, $userID);
}
else {
    local($errPage) = $kDocErrPagePath . $kErrInternalErrorTemplate;
    $gAssocList{"Body"} = "Find Documents failed!";
    &GenerateHTMLPage($errPage, *gAssocList, $kDocErrPagePath);
}

exit 0;

