#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	UpdateGroups.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     			Not to be copied, modified or redistributed without written
##     			permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/28/96	13:17	N		Original version
##
##*****************************************************************************

# This cgi will display a Login page

# to set the current directory ...
require "pwd.pl";
require Config;
use Cobalt::Group;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocDB.pl";
require "DocUtils.pl";
require "CreateInfobase.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

&VerifyUserAccess($kSuperAdminMode);

&LogToFileEnable($kErrorLogFile);

%dbassoc = ();
%dburlassoc = ();

&ReadDatabaseNames(\%dbassoc, \%dburlassoc);

$dbpath = $kDefaultBaseIBPath;
$dburl = $kDefaultBaseIBURL;
$dbdesc = "";
$dbname = "";

# for each group: create an infobase
my(@allGroups) = group_list();
GROUPLOOP: foreach $grp (@allGroups) {
	$result = $errNone;
	$dbname = $grp;

	if ($dbassoc{$dbname}) {
		next GROUPLOOP; #skip groups whose infobases already exist
	}
	$result = $errNone;
	$result = &CreateInfobase($dbname, $dbdesc, $dbpath, $dburl);

	if ($result != $errNone) {
		$result = 1;
		$gAssocList{"InfobaseDir"} = $dbname;
		$gAssocList{"errDuplicateDirectory"} = 1;
		last GROUPLOOP; #get out of loop if error
	}
}#for each group

if ($result == $errNone) {		
	# output page
    $templateFile = $kDocMsgPagePath .  $kMsgAllAdminOpSuccessfullTemplate;
    local(%assocList) = ();
    &GenerateHTMLPage($templateFile, *assocList, $kDocMsgPagePath);
}
else {
    $templateFile = $kDocDocPagePath .  $kDocDBCreateTemplate;
	$gAssocList{'Name'} = $dbname;
	$gAssocList{'Description'}  = $dbdesc;
	$gAssocList{'DefaultPath'} = $kDefaultDBPath;
	$gAssocList{'DefaultURL'} = $kDefaultDBURL;
	$gAssocList{"ADDERROR"} = 1;
   &GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
}

exit 0;
