#!/usr/bin/perl
##*****************************************************************************
##
##     File Name:	XHoistCategory.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	13:12	N		Original version
##
##*****************************************************************************


# to set the current directory ...
require "pwd.pl";
require Config;

# Use osname for portability switches (doubled to cheaply avoid -w warning)
my $osname = $Config::Config{'osname'} || $Config::Config{'osname'};

if ($osname eq "MSWin32") {
# under NT the Perl CGI script is not run from the directory in
# which the cgi script resides (i.e., current dir is not the cgi directory)
    my($thisFilePath) = $0;
    $thisFilePath =~ s/(.*)\\[\w\-]+\.[\w\-]+/$1\\/;
    if ($thisFilePath !~ /.+\\/) {
        $thisFilePath = ".\\";   # if no path available assume current directory
    }
    # now set the include path one directory levels higher
    my($requirePath) = $thisFilePath;
    $requirePath =~ s/(.*)\\[\w\-]+\\/$1/;

    push(@INC, "$requirePath\\cgi-bin\\");
    push(@INC, "$requirePath\\code\\");

    &chdir("$requirePath\\cgi-bin\\");
}
else { #for Unix etc. where Perl is invoked from the script's directory
    push(@INC, "../code/");
}
# --------------------------------------------------------------------------------
require "VerifySession.pl";

require "DocAPI.pl";
require "Listing.pl";
require "ShowDocuments.pl";
require "ShowCategories.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

# Read the query string
$lineread = &ReadQueryString();

# Create an associative list of (key value) pair
# of the input
%userAssocRecord = ();
&MakeAssociativeList($lineread, *userAssocRecord);

# Identify arguments that are mandatory.
@kMandatoryArguments = ();

# List of all arguments.
@kAllArguments = ("ID");

#Check if all the mandatory arguments are specified
@missingArguments = ();
#&CheckMandatoryFields(*kMandatoryArguments, *userAssocRecord, *missingArguments);
&CheckMissingArguments(*missingArguments, $kDocErrPagePath, $kErrMissingArgumentsTemplate);

$catID = $userAssocRecord{$kAllArguments[0]};
if (!defined($catID) || ($catID eq "")) {
    $catID = $kRootCategoryID;
}

$gAssocList{"InfoBase"} = &ReadInfoBaseName($kDocDBRootPath);

local(@categoryRecord) = ();

# set up the template directory
my($templatePath) = $kIBAnonymousTemplatePath;
$templatePath = $kAnonymousTemplatePath if (!(-d $templatePath)); 

$result = &OPGetCategory($catID, *categoryRecord, @kCatGetAllFieldsMask);
if($result == 0) {
    local(@categoryList) = &SListUnmake($categoryRecord[$kCategoryChildListIndex], $kValueSeperator);
    local($count) = $#categoryList + 1;
    if ($count || $catID == $kRootCategoryID) {
		&ShowCategories($catID, 0, *gAssocList, $templatePath . ($catID == $kRootCategoryID ? 'XU0.htm' : 'XU1.htm'), $templatePath, 1);
    }
    else {
		my($userID) = $gAssocList{$kUserIDCookie};
		$gAssocList{"DocViewType"} = &UMGetDocViewTypePrefFromUserID($userID);
		&ShowDocuments($catID, 0, *gAssocList, "", $userID, $templatePath . 'XU2.htm', $templatePath, 1);
    }
}
else {
	&RedirectURL("../cgi-bin/StaleObject.pl?obj=Category");
}
exit 0;


