# $Id: BaseDocGlobals.pl,v 1.6 1998/07/17 22:45:04 naga Exp $
# Copyright InfoPlace Inc., Milpitas, CA, USA, 1996-1998
# Not to be copied, modified or redistributed without written
# permission of InfoPlace.
#
# --------------------------------------------------------------------------------

require "DBGlobals.pl";
require "UMGlobals.pl";

# --------------------------------------------------------------------------------
# Define various Doc constants - REAL CONSTANTS (non-configurable)
# --------------------------------------------------------------------------------

# --------------------------------------------------------------------------------
# Constants

$kProductName = "InfoPlace Document Organizer";
$kProductVersion = "v1.3";
@kProductVersionSupported = ("v1.3");
$kProductFullVersion = "v1.3 (5/8/98)";

$kExportVersion1_1 = "e1.1";
$kExportVersion1_2 = "e1.2";
$kExportVersion = "e1.3";

$kConfigVersion = "c1.1";

$kMaxChildCategoryCount = 100;
$kMaxDocPerCategoryCount = 1000;
$kMaxDocumentCount = 10000;
$kMaxCategoryCount = 500;
$kMaxGlossaryCount = 4000;
$kMaxURLIDMapCount = 10000;
$kMaxIDDocsMapCount = 10000;

# Default Document Listing View Columns
# This can be overridden by system.conf file for new infobases
# This can be further overridden by user preferences
$kSystemDefaultDocColumns = "Author,CreationTime";

# --------------------------------------------------------------------------------
# DB Names


$kCategoryDB = "CategoryDB";
$kCategoryMapDB = "CategoryMapDB";
$kDocumentDB = "DocumentDB";
$kGlossaryDB = "GlossaryDB";
$kURLIDMapDB = "URLIDMapDB";
$kIDDocsMapDB = "IDDocsMapDB";

# --------------------------------------------------------------------------------
# DB Record Fields and Indices
#
# CategoryDB Fields:
@kCategoryDBFields = ("ID", "Name", "Parent", "ChildList", "DocIDList", "Description", "CreationTime", "ModificationTime", "IsObsolete");
@kCategoryDBFieldsTypes = ($kNumericTypeName, $kStringTypeName, $kNumericTypeName, 
						   $kListOfStringTypeName, $kListOfNumericTypeName,
						   $kStringTypeName, $kNumericTypeName,
						   $kNumericTypeName, $kNumericTypeName);
$kCategoryIDIndex = 0;
$kCategoryNameIndex = $kCategoryIDIndex + 1;
$kCategoryParentIndex = $kCategoryNameIndex + 1;
$kCategoryChildListIndex = $kCategoryParentIndex + 1;
$kCategoryDocIDListIndex = $kCategoryChildListIndex + 1;
$kCategoryDescIndex = $kCategoryDocIDListIndex + 1;
$kCategoryCreationTimeIndex = $kCategoryDescIndex + 1;
$kCategoryModificationTimeIndex = $kCategoryCreationTimeIndex + 1;
$kCategoryIsObsoleteIndex = $kCategoryModificationTimeIndex + 1;

# -----------------------------------------------------
# CategoryMapDB Fields:
@kCategoryMapDBFields = ("Name", "IDList");
@kCategoryMapDBFieldsTypes = ($kStringTypeName, $kListOfNumericTypeName);

$kCategoryMapNameIndex = 0;
$kCategoryMapIDListIndex = $kCategoryMapNameIndex + 1;

# -----------------------------------------------------
# DocumentDB Fields:
@kDocumentDBFields = ("DocID", "Name", "Author", "URL", "CreationTime", "ModificationTime",
					  "Version", "Size", "AppType", "Parents",
					  "PreviousVersionID", "NextVersionID", "IsObsolete",
					  "Keywords", "Description");

@kDocumentDBFieldsTypes = ($kNumericTypeName, $kStringTypeName, $kStringTypeName, $kStringTypeName, 
						   $kNumericTypeName, $kNumericTypeName,
						   $kNumericTypeName, $kNumericTypeName, $kStringTypeName, $kListOfStringTypeName,
						   $kNumericTypeName, $kNumericTypeName, $kNumericTypeName, $kListOfStringTypeName,
						   $kStringTypeName);

$kDocIDIndex = 0; 
$kDocNameIndex = $kDocIDIndex + 1; 
$kDocAuthorIndex = $kDocNameIndex + 1;
$kDocURLIndex = $kDocAuthorIndex + 1;
$kDocCreationTimeIndex = $kDocURLIndex + 1; 
$kDocModificationTimeIndex = $kDocCreationTimeIndex + 1; 
$kDocVersionIndex = $kDocModificationTimeIndex + 1; 
$kDocSizeIndex = $kDocVersionIndex + 1;  
$kDocAppTypeIndex = $kDocSizeIndex + 1;
$kDocCategoryListIndex = $kDocAppTypeIndex + 1; 
$kDocPreviousVersionIDIndex = $kDocCategoryListIndex + 1;
$kDocNextVersionIDIndex = $kDocPreviousVersionIDIndex + 1;
$kDocIsObsoleteIndex = $kDocNextVersionIDIndex + 1;
$kDocKeywordsIndex = $kDocIsObsoleteIndex + 1;
$kDocDescriptionIndex = $kDocKeywordsIndex + 1;

# -----------------------------------------------------
# GlossaryDB Fields:
@kGlossaryDBFields = ("Term", "Definition");
@kGlossaryDBFieldsTypes = ($kStringTypeName, $kStringTypeName);
$kGlossaryTermIndex = 0;
$kGlossaryDefinitionIndex = $kGlossaryTermIndex + 1;

# -----------------------------------------------------
# URLIDMapDB Fields:
@kURLIDMapDBFields = ("URL", "ID");
@kURLIDMapDBFieldsTypes = ($kStringTypeName, $kNumericTypeName);
$kURLMapURLIndex = 0;
$kURLMapIDIndex = $kURLMapURLIndex + 1;

# -----------------------------------------------------
# IDDocsMapDB Fields:
@kIDDocsMapDBFields = ("ID", "DocIDs");
@kIDDocsMapDBFieldsTypes = ($kNumericTypeName, $kListOfNumericTypeName);
$kIDMapIDIndex = 0;
$kIDMapDocIDsIndex = $kIDMapIDIndex + 1;

# -----------------------------------------------------
# Template filenames

# Error Pages
$kErrInternalErrorTemplate = "errInternalError.htm";
$kErrMissingArgumentsTemplate = "errMissingArguments.htm";
$kErrAddCategoryTemplate = "errAddCategory.htm";
$kErrAddDocumentTemplate = "errAddDocument.htm";
$kErrAddGlossaryTemplate = "errAddGlossary.htm";
$kErrEditCategoryTemplate = "errEditCategory.htm";
$kErrEditDocumentTemplate = "errEditDocument.htm";
$kErrEditGlossaryTemplate = "errEditGlossary.htm";
$kErrShowErrorLogTemplate = "errShowErrorLog.htm";
$kErrNoErrorLogTemplate = "errNoErrorLog.htm";
$kErrInvalidUserTemplate = "errInvalidUser.htm";

# Message Pages
$kMsgAddCategoryTemplate = "msgAddCategoryConfirm.htm";
$kMsgAddDocumentTemplate = "msgAddDocumentConfirm.htm";
$kMsgAddGlossaryTemplate = "msgAddGlossaryConfirm.htm";
$kMsgOpSuccessfullTemplate = "msgOpSuccessful.htm";
$kMsgIBAdminOpSuccessfullTemplate = "msgCurrentInfobaseOpSuccessful.htm";
$kMsgAllAdminOpSuccessfullTemplate = "msgAllAdminOpSuccessful.htm";
$kMsgUnderConstructionTemplate = "msgUnderConstruction.htm";

# Doc Pages

$kIndexPage = "index.htm";
$kStartPage = "Start.htm";
$kDocTopLevelTemplate = "U0.htm";
$kDocCategoriesTemplate = "U1.htm";
$kDocCategoryDocsTemplate = "U2.htm";
$kDocGlossaryTemplate = "U3.htm";
$kDocAddGlossaryTemplate = "U4.htm";
$kDocEditGlossaryTemplate = "U5.htm";
$kDocFindDocumentResultTemplate = "U6.htm";
$kDocFindCategoryResultTemplate = "U7.htm";
$kDocListCategriesTemplate = "U8.htm";   # obsolete variable
$kDocTOCTemplate = "U8.htm";
$kDocFindCategoryTemplate = "U9.htm";
$kDocFindDocumentTemplate = "U10.htm";
$kDocAddCategoryTemplate = "U11.htm";
$kDocAddDocumentTemplate = "U12.htm";
$kDocEditCategoryTemplate = "U13.htm";
$kDocEditDocumentTemplate = "U14.htm";
$kDocRemoveCategoryTemplate = "U15.htm";
$kDocRemoveDocumentTemplate = "U16.htm";
$kDocRemoveGlossaryTemplate = "U17.htm";
$kDocCategoryTemplate = "U18.htm";
$kDocumentTemplate = "U19.htm";
$kDocEditConfigurationTemplate = "U20.htm";
$kDocCommandsTemplate = "U21.htm";
$kDocIndexTemplate = "U22.htm";
$kDocLoginTemplate = "U23.htm";
$kDocEditWhatsNewTemplate = "U24.htm";
$kDocImportTemplate = "U25.htm";
$kDocExportTemplate = "U26.htm";
$kDocWhatsNewTemplate = "U27.htm";
$kDocShowUsersTemplate = "U28.htm";
$kDocShowGroupsTemplate = "U29.htm";
$kDocChangePasswordTemplate = "U30.htm";
$kDocChangePasswordResultTemplate = "U31.htm";
$kDocBlockSystemTemplate = "U32.htm";
$kDocGotoLoginPromptTemplate = "U33.htm";
$kDocAddUserTemplate = "U34.htm";
$kDocAddGroupTemplate = "U35.htm";
$kDocResetPasswordTemplate = "U36.htm";
$kDocEditUserTemplate = "U37.htm";
$kDocEditGroupTemplate = "U38.htm";
$kDocDBListingTemplate = "U39.htm";
$kDocEditDocPerfTemplate = "U40.htm";
$kDocDBCreateTemplate = "U41.htm";
$kDocCloseWindowTemplate = "U42.htm";
$kDocSystemVersionTemplate = "U43.htm";
$kDocDBCreateTemplate = "U44.htm";
$kDocDBEditTemplate = "U51.htm";
$kDocDBListTemplate = "U52.htm";
$kDocOrphanDocumentTemplate = "U53.htm";
$kDocLoginAlreadyTemplate = "U54.htm";
$kDocStaleObjectTemplate = "U55.htm";
$kDocAccessDeniedTemplate = "U56.htm";
$kDocAnonymousLoginTemplate = "U57.htm";
$kDocAnonymousLogoutTemplate = "U58.htm";
$kDocAnonymousLogoutURLTemplate = "U59.htm";
$kDocCookieSupportTemplate = "U60.htm";
$kDocumentDescTemplate = "U61.htm";

# --------------------------------------------------------------------------------
# Misc. globals

$kRootCategoryName = "Main";
$kRootCategoryID = 1;

$kKeywordSeperator = ',';
$kIndentSpaces = "    ";
$kCatagoryPathSeparator = "/";
$kImportExportFieldSeparator = "\t";
$kImportExportValueSeparator = "~,~";

# --------------------------------------------------------------------------------
# Operations error code

$errNone = 0;
$errOPFailed = 1;
$errDuplicateCategory = 2;
$errDuplicateGlossary = 2;
$errDuplicateRecord = 2;
$errParentDoesNotExist = 3;
$errEntryNotFound = 2;
$errInvalidPassword = 3;
$errInvalidSession = 4;
$errNoDB = 5;
$errCategoryInParent = 4;

# --------------------------------------------------------------------------------
#
$kAnonymousUserID = "anonymous";

# --------------------------------------------------------------------------------
# Config file names

# following indicates default infobase directory/url
$kDefaultBaseIBPath = '../../infobases/';
$kDefaultBaseIBURL = '/docorg/infobases/';

# following files are in infobase directory
$kIBDefaultFileName = 'defaults.conf';
$kIBInfobaseFileName = 'infobase.conf';

# Version file name
$kVersionFileName = 'version';

1;
