#
##*****************************************************************************
##
##     File Name:	DBGlobals.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	12:51	N		Original version
##
##*****************************************************************************


# --------------------------------------------------------------------------------
# Globals and Constants
# 

# 
# Defines DB specific constants
#
$kDBMetaDataFile = "MetaData";
$kDBDataFile = "Records";
$kDBMinBucketCount = 2;
$kDBMaxBucketCount = 8192;;
$kDBPerBucketCount = 100;  #Number of users per file
$kDBDefaultPermission = 0777;

#
# Defines the layout of the DBInfo list object
#
$kDBMagicNumberIndex = 0;
$kDBDirectoryIndex = 1;
$kDBAccessModeIndex = 2;
$kDBBucketCountIndex = 3;
$kDBFieldCountIndex = 4;
$kDBFieldNamesIndex = 5;
$kDBFieldTypesIndex = 6;
$kDBBucketIndex = 7;

#
# Defines the DB access modes
#
$kDBWriteAccess = 1;
$kDBReadAccess = 0;

#
# Misc. constants
#
$kFieldSeperator = '~#~';  # used in too many places; keep it
$kValueSeperator = ',';  # used in too many places; keep it
$kFieldSeparator = '~#~';
$kValueSeparator = ',';
$kDBPathNameSeparator = '/';
$kDBMagicNumber = 275683;
$kNTimesWaitOneSecondAndTry = 10;
$kSecondsToWaitBeforeRetry = 1;

#
# Field Types
#
$kUnkownType = 0;
$kStringType = 1;
$kNumericType = 2;
$kListOfStringType = 3;
$kListOfNumericType = 4;

$kkDBFieldTypeCount = 5;

$kUnknownTypeName = "unknown";
$kStringTypeName = "string";
$kNumericTypeName = "numeric";
$kListOfStringTypeName = "stringlist";
$kListOfNumericTypeName = "numericlist";

$kDBFieldTypeNames = ($kUnknownTypeName, $kStringTypeName, $kNumericTypeName, 
					$kListOfStringTypeName, $kListOfNumericTypeName);

%kDBFieldTypeNameIndexAssoc = ($kUnknownTypeName, $kUnkownType, 
							$kStringTypeName, $kStringType,
							$kNumericTypeName, $kNumericType,
							$kListOfStringTypeName, $kListOfStringType,
							$kListOfNumericTypeName, $kListOfNumericType);
