# $Id: DocUtility.pl,v 1.1 1998/05/04 19:50:02 naga Exp $
# Copyright InfoPlace Inc., Milpitas, CA, USA, 1996-1998
# Not to be copied, modified or redistributed without written
# permission of InfoPlace.
#
# --------------------------------------------------------------------------------

require "LogMsg.pl";

# --------------------------------------------------------------------------------
#

sub GetAndIncrementMasterID
{
	my($file) = @_;
	my($id);
	if (!open(IDFILE, "+<$file")) {
		&LogFileOpenFailMsg($file);
		return 0;
	}
	&GetWriteLockOnFile("IDFILE") || &LogMsg("GetAndIncrementMasterID::GetWriteLockOnFile failed on file handle $file: $!");

	$id = int(<IDFILE>);
	$id++;
	seek(IDFILE, 0, 0);
	print IDFILE "$id\n";

	close(IDFILE);	
	&UnlockFile("IDFILE") || &LogMsg("GetAndIncrementMasterID::UnlockFile failed on file handle $file: $!");
	return $id - 1;
}

sub GetMasterID
{
	my($file) = @_;
	my($id);
	if (!open(IDFILE, "<$file")) {
		&LogFileOpenFailMsg($file);
		return 0;
	}
	&GetReadLockOnFile("IDFILE") || &LogMsg("GetMasterID::GetReadLockOnFile failed on file handle $file: $!");
	$id = int(<IDFILE>);

	close(IDFILE);	
	&UnlockFile("IDFILE") || &LogMsg("GetMasterID::UnlockFile failed on file handle $file: $!");
	return $id;
}

1;
