# $Id: DocUtils.pl,v 1.3 1998/05/26 18:10:10 thyag Exp $
# Copyright InfoPlace Inc., Milpitas, CA, USA, 1996-1998
# Not to be copied, modified or redistributed without written
# permission of InfoPlace.
#
# --------------------------------------------------------------------------------

require "DocAPI.pl";
require "CGIUtility.pl";

# --------------------------------------------------------------------------------
sub GetCategoryParentSelectList
{
    my($parent, $self) = @_;
    my(@catNames) = ();
	my(@catIDs) = ();
    my($result) = &OPGetAllCategoriesName(\@catIDs, \@catNames, 1, 3);
    my($parentsHTMLString) = "";
    my($parentCount) = $#catNames + 1;
    my($i);
    for ($i = 0; $i < $parentCount; $i++) {
		my($id) = $catIDs[$i];
		if($id != $self) { # exclude the category whose parent list is being created
			my($name) = &GetCategoryPath($id, 1, 1);
			my($selected) = ($parent eq $id) ? "SELECTED" : "";
			$parentsHTMLString = $parentsHTMLString . "<OPTION VALUE=\"" . $id . "\" $selected>$name\n";
		}#if same as self
    }
    return $parentsHTMLString;
}

# --------------------------------------------------------------------------------
sub GetDocumentParentSelectList
{
    local(*parents) = @_;
    my(@catNames) = ();
    my(@catIDs) = ();
    my($result) = &OPGetAllCategoriesName(\@catIDs, \@catNames, 1, 2);
    my($parentsHTMLString) = "";
    my($parentCount) = $#catNames + 1;
    my($i);
	
	if(($parentCount == 1) && ($catIDs[0] == $kRootCategoryID)) { #only Main category exists
		return $parentsHTMLString; 
	}

    for ($i = 0; $i < $parentCount; $i++) {
		my($id) = $catIDs[$i];
		my($name) = &GetCategoryPath($id, 1, 1);
		my($selected) = (&MemberOf($id, *parents)) ? "SELECTED" : "";
		$parentsHTMLString = $parentsHTMLString . "<OPTION VALUE=\"" . $id . "\" $selected>$name\n";
    }
    return $parentsHTMLString;
}

# --------------------------------------------------------------------------------
# Given a category name, returns a hot link path of the
# category from root category.
sub GetCategoryLinkPath
{
	my($catID) = @_;
	if ($catID eq "" || $category eq $kRootCategoryID) {
		return "";
	}
	my(@record) = ();
	my($catName);
	my($path) = "";
	my($firsttime) = 1;
	my($separator) = "";
	while ($catID ne $kRootCategoryID) {
		if ($firsttime) {
			$firsttime = 0;
		}
		else {
			$separator = $kCatagoryPathSeparator;			
		}
		my($result) = &OPGetCategory($catID, \@record);
		$catName = $record[$kCategoryNameIndex];
		$path = "<A HREF=\"javascript:top.buffer.gotoCategory(window, '" . &EncodeForURL($catName) . "', ${catID})\">" . 
                $catName . "</A>" . $separator . $path;
		if($result == $errNone) {
			$catID = $record[$kCategoryParentIndex];
		}
		else {
			$catID = $kRootCategoryID;
			&LogMsg("GetCategoryLinkPath::Couldn't find category - $catID");
		}
	}
	$path = "<A HREF=\"../cgi-bin/TopLevel.pl\">" . $kRootCategoryName . "</A>/" . $path;
}

# --------------------------------------------------------------------------------
# Given a category name, returns a hot link path of the
# category from root category. This is used for published pages.
sub XGetCategoryLinkPath
{
	my($catID) = @_;
	if ($catID eq "" || $category eq $kRootCategoryID) {
		return "";
	}
	my(@record) = ();
	my($catName);
	my($path) = "";
	my($firsttime) = 1;
	my($separator) = "";
	while ($catID ne $kRootCategoryID) {
		if ($firsttime) {
			$firsttime = 0;
		}
		else {
			$separator = $kCatagoryPathSeparator;			
		}
		my($result) = &OPGetCategory($catID, \@record);
		$catName = $record[$kCategoryNameIndex];
		$path = "<A HREF=\"../cgi-bin/XHoistCategory.pl?ID=${catID}\">" . 
                $catName . "</A>" . $separator . $path;
		if($result == $errNone) {
			$catID = $record[$kCategoryParentIndex];
		}
		else {
			$catID = $kRootCategoryID;
			&LogMsg("GetCategoryLinkPath::Couldn't find category - $catID");
		}
	}
	$path = "<A HREF=\"../cgi-bin/XHoistCategory.pl\">" . $kRootCategoryName . "</A>/" . $path;
}

# --------------------------------------------------------------------------------
# Given a category id, returns the path of the
# category from root category.
sub GetCategoryPath
{
	my($catID, $includeSelf, $partial) = @_;
	if ($catID eq "" || $catID eq $kRootCategoryID) {
		return ($includeSelf ? $kRootCategoryName : "");
	}
	if (!defined($partial)) {
		$partial = 0;
	}
	my(@record) = ();
	if (!$includeSelf) {
		&OPGetCategory($catID, \@record);
		$catID = $record[$kCategoryParentIndex];
	}
	if ($catID eq "" || $catID eq $kRootCategoryID) {
		return $kRootCategoryName;
	}
	my($path) = "";
	my($firsttime) = 1;
	my($separator) = "";
	my($done) = 0;
	while ($catID ne $kRootCategoryID && !$done) {
		if ($firsttime) {
			$firsttime = 0;
		}
		else {
			$separator = $kCatagoryPathSeparator;			
		}
		my($result) = &OPGetCategory($catID, \@record);
		if($result == $errNone) {
			my($catName) = $record[$kCategoryNameIndex];
			$path = $catName . $separator . $path;
			if ($partial && &GetCategoryIDFromName($catName)) {
				return $path;
			}
			$catID = $record[$kCategoryParentIndex];
		}
		else {
			$catID = $kRootCategoryID;
			&LogMsg("GetCategoryLinkPath::Couldn't find category - $catID");
		}
	}
	$path = $kRootCategoryName . $kCatagoryPathSeparator . $path;
}

# --------------------------------------------------------------------------------
# Given a category name, returns the category id, if the given name has ONLY one
# category, else returns 0

sub GetCategoryIDFromName
{
	my($name) = @_;
	my($id) = 0;
	my(@db) = ();
	my($result) = &DBOpen($kCategoryMapDB, $kDocDBPath, $kDBReadAccess, \@db);
	if ($result == $errNone) {
		my(@record) = ();
		$result = &DBRetreiveRecord(\@db, $name, \@record);
		if ($result == $errNone) {
			my(@x) = split($kValueSeperator, $record[$kCategoryMapIDListIndex]); 
			if ($#x == 0) {
				$id = $x[0];
			}
		}
	}
	&DBClose(\@db);
	return $id;
}

# --------------------------------------------------------------------------------
# Given a category name, returns the category ids list.
sub GetCategoryIDsFromName
{
	my($name) = @_;
	my(@db) = ();
	my(@l) = ();
	my($result) = &DBOpen($kCategoryMapDB, $kDocDBPath, $kDBReadAccess, \@db);
	if ($result == $errNone) {
		my(@record) = ();
		$result = &DBRetreiveRecord(\@db, $name, \@record);
		if ($result == $errNone) {
			@l = split($kValueSeperator, $record[$kCategoryMapIDListIndex]); 
		}
	}
	&DBClose(\@db);
	return $l;
}
# --------------------------------------------------------------------------------
# Given a category path, returns the category id, if the given path does not exist
# return 0. 
sub GetCategoryIDFromPath
{
	my($path) = @_;
	if (!defined($path) || $path eq "") {
		return 0;
	}
	my(@cats) = split($kCatagoryPathSeparator, $path);
	my(@db) = ();
	my($result) = &DBOpen($kCategoryDB, $kDocDBPath, $kDBReadAccess, \@db);
	my($firstTime) = 1;
	my($nextID) = 0;
	foreach $cat (@cats) {
		if ($firstTime) {
			$firstTime = 0;
			$nextID = &GetCategoryIDFromName($cat);
			if (!$nextID) {
				return 0;
			}
		}
		else {
			my(@record) = ();
			$result = &DBRetreiveRecord(\@db, $nextID, \@record);
			if ($result == $errNone) {
				if(!&IsCategoryInList(\@db, $cat, $record[$kCategoryChildListIndex], \$nextID)) {
					return 0;
				}
			}
			else {
				return 0;
			}
		}
	}
	&DBClose(\@db);
	return $nextID;
}

# --------------------------------------------------------------------------------
# check if $cat (category name) is in the list of category ids. The $catID is set
# to the category found. returns 1 if found else 0.
sub IsCategoryInList
{
	local(*db, $cat, $clist, *catID) = @_;
	my(@childlist) = split($kValueSeparator, $clist);
	my($found) = 0;
	my($count) = $#childlist + 1;
	my($i) = 0;
	while ($i < $count && !$found) {
		my($child) = $childlist[$i++];
		$result = &DBRetreiveRecord(*db, $child, \@record);
		if ($result == $errNone) {
			if ($cat eq $record[$kCategoryNameIndex]) {
				$found = 1;
				$catID = $child;
			}
		}
	}
	return $found;
}

# --------------------------------------------------------------------------------
sub IsCatDocNameInProperCharSet 
{
	my($name) = @_;
	if ($name =~ /^[A-Za-z0-9_ \-\!\:\+\?\*\.\'\$\&\(\)\<\>\;\,\[\]\{\}\=\%\#\@\^\"\`\|\\]*$/) {
		return 1;
	}
	return 0;
}


# --------------------------------------------------------------------------------
sub IsNameInProperCharSet 
{
	my($name) = @_;
	if ($name =~ /^[A-Za-z0-9_\- !:]*$/) {
		return 1;
	}
	return 0;
}

1;
