##*****************************************************************************
##
##     File Name:	Glossary.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	12:51	N		Original version
##
##*****************************************************************************


require "LogMsg.pl";
require "CGIUtility.pl";
require "DocAPI.pl";
require "Listing.pl";

# The following routine will generate an associated list to represent
# each category in the table view as a cell.
# Each cell contains an Image, its link, a Title string and its link.
# Therefore, 4 items needs to be generated per cell in the last parameter.
# The %valueList is used to return the values with keywords using the row#:
# eg. Term1 = "new term";  
#	  Definition1 = "description of term"
# the third arg $edit indicates whther to present a editable view
sub GenGlossaryTableCells
{	
	local(*glossaryList, *valueList, $edit) = @_;
	local(@sortedList) = &SortRecordsOnField(*glossaryList, 1);
	local($i, $count) = (0, $#sortedList + 1);
	for ($i = 0; $i < $count; $i++) {
		local($glossary) = $sortedList[$i];
		local($term) = &SListNthElement($glossary, $kGlossaryTermIndex, $kFieldSeperator);
		local($def) = &SListNthElement($glossary, $kGlossaryDefinitionIndex, $kFieldSeperator);
		local(@keyList) = ("TermRow${i}", "EncodedTermRow${i}", "EditIconRow${i}", "DefinitionRow${i}");
		my($encodedTerm) = &EncodeForURL($term);
		$valueList{$keyList[0]} = $term;
		$valueList{$keyList[1]} = $encodedTerm;
		if ($edit ) {
			$valueList{$keyList[2]} = "<A HREF=\"../cgi-bin/EditGlossaryForm.pl?$kGlossaryDBFields[$kGlossaryTermIndex]=$encodedTerm\">\n" . '<IMG SRC="../images/EditIcon.gif" HEIGHT=15 WIDTH=10></A>' . " <A HREF=\"../cgi-bin/RemoveGlossaryConfirm.pl?$kGlossaryDBFields[$kGlossaryTermIndex]=$term\">\n" . '<IMG SRC="../images/RemoveIcon.gif" HEIGHT=15 WIDTH=10></A>';
		}
		else {
			$valueList{$keyList[2]} = "";
		}
		$valueList{$keyList[3]} = $def;
	}
}


# --------------------------------------------------------------------------------

sub ShowGlossaryTerms
{
  local($edit, *assocList) = @_;
  local($templateFile) = $kDocDocPagePath . $kDocGlossaryTemplate;
  local($totalCells, $numCellsPerRow) = (1, 1);
  local(@glossaryList) = ();
  local($result) = &OPGetAllGlossaries(*glossaryList);
  if ($result) {
    $assocList{"MODECHANGE"} = 1;
    if ($edit) {
      $assocList{"EDITMODE"} = 1;
      $assocList{"EditModeLabel"} = "Exit Edit Mode";
      $assocList{"EditModeCGI"} = "ShowGlossary.pl";
    }
    else {
      $assocList{"EditModeLabel"} = "Enter Edit Mode";
      $assocList{"EditModeCGI"} = "ShowGlossary.pl?Edit=true";
    }
    local($count) = $#glossaryList + 1;
    if ($count == 0) {
      $assocList{"NoGlossary"} = "No Glossary Terms Defined";
    }
    else {
      $assocList{"NoGlossary"} = "";
      $assocList{"TABLEEXISTS"} = 1;
      &GenGlossaryTableCells(*glossaryList, *assocList, $edit);
      $numCellsPerRow = 2;
      $totalCells = ($#glossaryList + 1) * 2;  # 2 cells per glossary item (row)
      }
    &GenerateHTMLFromTemplate($templateFile, $totalCells, $numCellsPerRow, *assocList, $kDocDocPagePath);
  }
  else {
    local($errMsg) = "Failed to get the Glossary";
    &LogMsg($errMsg);
    local($errPage) = $kDocErrPagePath . $kErrInternalErrorTemplate;
    local(%assocList) = ("Body", $errMsg);
    &GenerateHTMLPage($errPage, *assocList, $kDocErrPagePath);
  }
  return 0;
}

