# $Id: Listing.pl,v 1.4 1998/07/14 22:03:55 naga Exp $
# Copyright InfoPlace Inc., Milpitas, CA, USA, 1996-1998
# Not to be copied, modified or redistributed without written
# permission of InfoPlace.
#
# --------------------------------------------------------------------------------

require "LogMsg.pl";
require "CGIUtility.pl";
require "DocAPI.pl";

# --------------------------------------------------------------------------------
# Execute ...
#

sub BuildCategoryLabel
{
	my($name, $id) = @_;
	my($encodeName) = &EncodeForURL($name);
	return "<A HREF=\"javascript:top.buffer.gotoCategory(window, \'${encodeName}\', ${id})\"><B>${name}</B></A>";
}

sub XBuildCategoryLabel
{
	my($name, $id) = @_;
	return "<A HREF=\"../cgi-bin/XHoistCategory.pl?ID=${id}\"><B>${name}</B></A>";
}

# dead code
#sub BuildDocumentLabel
#{
#	local(*record, $isBold) = @_;
#	my($name) = $record[$kDocNameIndex];
#	my($encodeName) = &EncodeForURL($name);
#	my($url) = &EncodeForURL($record[$kDocURLIndex]);
#	return ($isBold) ? "<A HREF=\"javascript:gotoDocument(\'${encodeName}\', \'${url}\')\">\n<B>${name}</B></A>" :
#		"<A HREF=\"javascript:gotoDocument(\'${encodeName}\', \'${url}\')\">\n${name}</A>";
#}


sub SortRecord
{
	# $a and $b are pre-defined variables for sort, a pre-built function.
	my($aa, $bb);
	$aa = &SListNthElement($a, $fieldIndex - 1, $kFieldSeperator);
	$bb = &SListNthElement($b, $fieldIndex - 1, $kFieldSeperator);
	$aa =~ tr/A-Z/a-z/;
	$bb =~ tr/A-Z/a-z/;
	return ($aa cmp $bb);
}

sub SortRecordsOnField
{
	local(*categoryList, $fieldIndex) = @_;
	return sort SortRecord @categoryList;
}

sub RecurseThruCategories
{
	local($id, $indentLevel, *data, *openCategories, $userID, *assocList, $publishMode) = @_;
	my($i, $j);

	my(@category) = ();
	&OPGetCategory($id, \@category);
	my($name) = $category[$kCategoryNameIndex];
	my($docList) = $category[$kCategoryDocIDListIndex];
	my($count) = &SListLength($docList, $kValueSeperator);
	my($children) = $category[$kCategoryChildListIndex];
	my($subCategoryCount) = &SListLength($children, $kValueSeperator);
	my($anyChildren) = ($count) ? 1 : ($subCategoryCount ? 1 : 0);
	my($opencat) = &MemberOf($id, *openCategories);
	my($encodedName) = ($opencat) ? "" : &EncodeForURL($name);
	my($imagestmt) = ($count) ? 
		(($opencat) ? 
		 "<A HREF=\"../cgi-bin/TOC.pl\"><IMG SRC=../images/OpenFolder.gif BORDER=0 ALIGN=BOTTOM></A>" :
		"<A HREF=\"../cgi-bin/TOC.pl?OpenCategory=$id\"><IMG SRC=../images/ClosedFolder.gif BORDER=0 ALIGN=BOTTOM></A>") :
			"<IMG SRC=../images/OpenFolder.gif BORDER=0 ALIGN=BOTTOM>";

	$data = $data . ($publishMode ? '' : $imagestmt) . ($publishMode ? &XBuildCategoryLabel($name, $id) : &BuildCategoryLabel($name, $id)) . "<BR>\n";
	if ($subCategoryCount) {
	    $data = $data . "<UL PLAIN>";
	}
	$indentLevel++;
	if ($opencat) {
		my(@documentList) = &SListUnmake($docList, $kValueSeperator);
		for ($i = 0; $i < $count; $i++) {
			my(@record) = ();
			my($docID) = $documentList[$i];
			&OPGetDocument($docID, \@record);
			$documentList[$i] = &SListMake(\@record, $kFieldSeperator);
		}
		@documentList = &SortRecordsOnField(\@documentList, $kDocNameIndex + 1);
		if ($count) {
			my($columnCount);
			my(%newAssocList) = ();
			$columnCount = &PrepareDocColumnsForListing($userID, \%newAssocList);
			my($whatsNewTime) = &UMComputeUsersWhatsNewTime($userID);
			&AddDocumentsToTableCells(\@documentList, $count, 0, \%newAssocList, $whatsNewTime);
			$data = $data . &ProcessHTMLFromTemplate($kDocDocPagePath . ($publishMode ? 'XDocTable.htm' : 'DocTable.htm'), $columnCount*$count, $columnCount, \%newAssocList, $kDocDocPagePath); 	
			$assocList{'DOCTABLEEXISTS'} = 1;
		}
	}
	my(@categoryList) = &SListUnmake($children, $kValueSeperator);
	for ($i = 0; $i < $subCategoryCount; $i++) {
		my($element) = $categoryList[$i];
		&OPGetCategory($element, \@category);
		$categoryList[$i] = &SListMake(\@category, $kFieldSeperator);
	}
	@categoryList = &SortRecordsOnField(\@categoryList, 2);
	for ($i = 0; $i < $subCategoryCount; $i++) {
		my($element) = &SListNthElement($categoryList[$i], $kCategoryIDIndex, $kFieldSeperator);
		&RecurseThruCategories($element, $indentLevel, *data, *openCategories, $userID, *assocList, $publishMode);
	}
	if ($subCategoryCount) {
	    $data = $data . "</UL>";
	}
}

sub GetDocColumnsForUser 
{
	my($userID) = @_;
	my($columns) = "";
	&UMGetDocColumnsFromProfile($userID, \$columns);
	if ($columns eq "") {
      $columns = $kDefaultDocColumnNames;
    }
	return $columns;
}

sub PrepareDocColumnsForListing
{
	local($userID, *assocList) = @_;
	my(@columnList) = split("\,", &GetDocColumnsForUser($userID));
	foreach $c (@columnList) {
      $assocList{"COLUMN" . $c} = 1;
    }
	return $#columnList + 1;
}

sub BuildUserTableCells
{	
    local(*userList, $count, $index, *assocList) = @_;
    my($i) = 0; 
    my(@sortedUsers) = &SortRecordsOnField(*userList, 1);
    for ($i = 0; $i < $count; $i++) {
		my(@user) = &SListUnmake($sortedUsers[$i], $kFieldSeperator);
		&UserAddTableCell(\@user, $index, *assocList);
		$index++;
    }
}

sub UserAddTableCell
{
    local(*user, $i, *valueList) = @_;
    my(@keyList) = ("UserIDRow" . $i, 
					"EditIconRow" . $i, # these two are in the same cell
					"NameRow" . $i, 
#					"EmailRow" . $i
					"TypeRow" . $i
					);
    $valueList{$keyList[0]} = $user[$kUserProfileUserIDIndex];
    $valueList{$keyList[1]} = "";
    $valueList{$keyList[2]} = $user[$kUserProfileNameIndex];
    #$valueList{$keyList[3]} = $user[$kUserProfileEmailIndex];
    $valueList{$keyList[3]} = $user[$kUserProfileOtherPrefsIndex+1]; #last item is user type
}

sub BuildGroupTableCells
{	
    local(*groupList, $count, $index, *assocList) = @_;
    my($i) = 0; 
    my(@sortedGroups) = &SortRecordsOnField(*groupList, 1);
    for ($i = 0; $i < $count; $i++) {
		my(@group) = &SListUnmake($sortedGroups[$i], $kFieldSeperator);
		&GroupAddTableCell(\@group, $index, *assocList);
		$index++;
    }
}

sub GroupAddTableCell
{
    local(*group, $i, *valueList) = @_;
    my(@keyList) = ("NameRow" . $i, 
					"EditIconRow" . $i # these two are in the same cell
					);
    $valueList{$keyList[0]} = $group[$kGroupNameIndex];
    $valueList{$keyList[1]} = "";
}

sub BuildDocumentTableCells
{	
	local(*documentList, *valueList, *totalCells, $context, $whatsNewTime) = @_;
	my(@sortedList) = &SortRecordsOnField(*documentList, 1);
	my($i, $count) = (0, $#sortedList + 1);
	for ($i = 0; $i < $count; $i++) {
		my($document) = $sortedList[$i];
		my(@record) = split($kFieldSeperator, $document);
		&DocumentAddTableCell(\@record, $i, *valueList, *totalCells, $context, $whatsNewTime);
	}
}

sub BuildDocumentTableCells2
{
	local(*docids, $userID, *data) = @_;
	my(@documentList);
	my($i, $count);
	my(@record);
	$count = $#docids + 1;
	for ($i = 0; $i < $count; $i++) {
		@record = ();
		my($docID) = $docids[$i];
		&OPGetDocument($docID, \@record);
		$documentList[$i] = &SListMake(\@record, $kFieldSeperator);
	}
	@documentList = &SortRecordsOnField(\@documentList, $kDocNameIndex + 1);
	if ($count) {
		my($columnCount);
		my(%newAssocList) = ();
		$columnCount = &PrepareDocColumnsForListing($userID, \%newAssocList);
		my($whatsNewTime) = &UMComputeUsersWhatsNewTime($userID);
		&AddDocumentsToTableCells(\@documentList, $count, 0, \%newAssocList, $whatsNewTime);
		$data = $data . &ProcessHTMLFromTemplate($kDocDocPagePath . "DocTable.htm", $columnCount*$count, $columnCount, \%newAssocList, $kDocDocPagePath); 	
	}
}

sub DocumentAddTableCell
{
	local(*document, $i, *valueList, *cellCount, $edit, $context, $whatsNewTime) = @_;
	my(@keyList) = ("URLRow" . $i, 
					"NameRow" . $i, 
					"EditIconRow" . $i, # these two are in the same cell
					"AuthorRow" . $i, 
					"CreationTimeRow" . $i,
					"ModificationTimeRow" . $i, 
					"VersionRow" . $i,
					"SizeRow" . $i,
					"AppTypeRow" . $i,
					"DescriptionRow" . $i, 
					"KeywordsRow" . $i, 
					"NewDocRow" . $i, 
					"EscapedNameRow" . $i,
					"EscapedURLRow" . $i
					);
	$cellCount= ($cellCount - 1) + $#keyList; #add cells per row (URL and Edit icon are not cells)
	my($docurl) = &GetDocURL($document[$kDocURLIndex], $document[$kDocIDIndex]);
	$valueList{$keyList[0]} = $docurl;
	$valueList{$keyList[13]} = &EncodeForURL($docurl);
	$valueList{$keyList[1]} = $document[$kDocNameIndex];
	$valueList{$keyList[3]} = $document[$kDocAuthorIndex];
	$valueList{$keyList[4]} = &GetTimeFormatted($document[$kDocCreationTimeIndex]);
	$valueList{$keyList[5]} = &GetTimeFormatted($document[$kDocModificationTimeIndex]);
	$valueList{$keyList[6]} = $document[$kDocVersionIndex];
	$valueList{$keyList[7]} = $document[$kDocSizeIndex];
	$valueList{$keyList[8]} = $document[$kDocAppTypeIndex];
	$valueList{$keyList[9]} = $document[$kDocDescriptionIndex] ? $document[$kDocDescriptionIndex] : "";
	$valueList{$keyList[10]} = $document[$kDocKeywordsIndex] ? $document[$kDocKeywordsIndex] : "";
	$valueList{$keyList[11]} = ($whatsNewTime && ($document[$kDocCreationTimeIndex] >= $whatsNewTime)) ? '<IMG SRC="../images/NewDoc.gif" BORDER=0>' : "";
	$valueList{$keyList[12]} = &EncodeForURL($document[$kDocNameIndex]);

	$valueList{"DocIDRow" . $i} = $document[$kDocIDIndex];
}

sub GetDocURL
{
	my($url, $docID) = @_;
	if ($url =~ /^(\$INFOBASE\/)(.*)/) {
		$url = $kGetDocCGIURL . $2; 
	}
	elsif ($url eq '') {
		$url = $kGetDocDescCGIURL . "$docID";
	}
	return $url;
}

#sub CheckAbsoluteURLPath
#{
#	my($url) = @_;
#	if ($url =~ /^(\$INFOBASE\/)(.*)/) {
#		$url = $kGetDocCGIURL . $2; 
#	}
#	return $url;
#}

sub IsAbsoluteURLPath
{
	my($url) = @_;
	if ($url =~ /^(\$INFOBASE\/)(.*)/) {
		return 0;
	}
	return 1;
}

# latest version for category listing 
sub GenCategoryTableCells
{
	local(*categoryList, *valueList) = @_;
	my(@sortedList) = &SortRecordsOnField(*categoryList, 2);
	my($i, $count) = (0, $#sortedList + 1);
	#use $j instead of $i since only non 'root' categories are to be indexed
	my($j) = 0; 
	for ($i = 0; $i < $count; $i++) {
		my($category) = $sortedList[$i];
		my($id) = &SListNthElement($category, $kCategoryIDIndex, $kFieldSeperator);
		my($name) = &SListNthElement($category, $kCategoryNameIndex, $kFieldSeperator);
		if ($id != $kRootCategoryID) {
			$valueList{"Title${j}"} = $name;
			$valueList{"EscapedTitle${j}"} = &EncodeForURL($name);
			$valueList{"ID${j}"} = $id;
			$j++;
		}
	}
	return $j;
}

sub AddDocumentsToTableCells
{	
	local(*docList, $count, $index, *assocList, $whatsNewTime, $alphaRange) = @_;
	my($i) = 0; 
	my($cellCount) = 0;
    my($addedDocCount) = 0;
    my($docsAddedFlag) = 0;
	if($alphaRange) { # assumes the docs are sorted alphabetically on title
        $alphaRange =~ tr/[a-z]/[A-Z]/; #make it all upper case
        if($alphaRange =~ /([A-Z])-([A-Z])/) {
            my($originalRange) = $alphaRange;
            $alphaRange =~ tr/[A-Z]/[a-z]/; #make it all lower case
            $alphaRange = '[' . $originalRange . $alphaRange . ']';
        }
	}
  DOCLOOP: 
	for ($i = 0; $i < $count; $i++) {
		my(@document) = &SListUnmake($docList[$i], $kFieldSeperator);
		my($excludeFlag) = 0;
		if ($alphaRange && ($document[$kDocNameIndex] !~ /^${alphaRange}(.)*/)) {
		    $excludeFlag = 1;
			if($docsAddedFlag) {
				last DOCLOOP; #break out of the for loop
			}
		}
	    if(!$excludeFlag) {
			&DocumentAddTableCell(\@document, $index, *assocList, \$cellCount, 0, "", $whatsNewTime);
			$index++;
			$addedDocCount++;
			$docsAddedFlag = 1;
		}
   }
   return $addedDocCount;
}

1;
