##*****************************************************************************
##
##     File Name:	SList.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	12:52	N		Original version
##
##*****************************************************************************


sub SListMake
{
	local(*list, $seperator) = @_;
	return join($seperator, @list);
}

sub SListUnmake
{
	local($list, $seperator) = @_;
	# remove whitespace from the list, i.e., space and tab
	# ???
	return split(/$seperator/, $list);
}

sub SListAppend
{
	local($list, $element, $seperator) = @_;
	local(@record);
	@record = split(/$seperator/, $list); 
	push(@record, $element);
	return join($seperator, @record);
}

sub SListRemove
{
	local($list, $element, $seperator) = @_;
	local(@record);
	@record = split(/$seperator/, $list); 
	local($count) = $#record + 1;
	local($i);
	for ($i = 0; $i < $count; $i++) {
		if ($record[$i] eq $element) {
			splice(@record, $i, 1);
			break;
		}
	}
	return join($seperator, @record);
}

sub SListReplace
{
	local($list, $element, $newelement, $seperator) = @_;
	local(@record);
	@record = split(/$seperator/, $list); 
	local($count) = $#record + 1;
	local($i);
	for ($i = 0; $i < $count; $i++) {
		if ($record[$i] eq $element) {
			$record[$i] = $newelement;
			break;
		}
	}
	return join($seperator, @record);
}

sub SListNthElement
{
	local($list, $index, $seperator) = @_;
	local(@record);
	@record = split(/$seperator/, $list); 
	local($count) = $#record + 1;
	if ($index < $count) {
		return $record[$index];
	}
	local($x); # return a undefined value
	return $x;
}

sub SListLength
{
	local($list, $seperator) = @_;
	local(@record);
	@record = split(/$seperator/, $list); 
	return $#record + 1;
}

1;

