#    
##*****************************************************************************
##
##     File Name:	SessionUtils.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	12:51	N		Original version
##
##*****************************************************************************

# --------------------------------------------------------------------------------
#
require "SetGlobals.pl";
require "UMAPI.pl";

# --------------------------------------------------------------------------------
#
sub GetRawCookies 
{
	local(*cookieJar) = @_;
	my(@cookies) = split (/; /, $ENV{ 'HTTP_COOKIE' });
	foreach $cv (@cookies) {
		my(@pairs) = split (/=/, $cv);
		$cookieJar{$pairs[0]} = $pairs[1];
	}
}

# --------------------------------------------------------------------------------
#
sub GetCookies 
{
	my($cookie) = @_;
	my(%cookieJar) = ();
	&GetRawCookies(\%cookieJar);
	return split(/#/, &DecodeCookieValue($cookieJar{$cookie}));
}

# --------------------------------------------------------------------------------
#
sub IsValidSession
{
	my(@cookies) = &GetCookies($kLoadedSessionIDCookie);
	my($result) = 0;
	
	if ($#cookies > 1) {
		my($sessionID) = $cookies[0];
		my($path) = $cookies[1];
		my($url) = $cookies[2];
		my($isanonymous) = $cookies[3];
		my($logouturl) = $cookies[4];
		my($close) = $cookies[5];
		
		my($tmppath) = $path;
		chop $tmppath;
		if( -d $tmppath ) { #if directory exists (infobase was not deleted by someone)
			# THIS WILL SET ALL INFOBASE DEPENDENT GLOBALS ...
			# Other globals are already set by the fact that SetGlobals.pl is 'required'
			&SetAllGlobals($path, $url);
			my($userID) = "";
			$result = &UMGetUserIDFromSessionID($sessionID, \$userID);
			$result = ($result != $errNone || $userID eq "")  ? 0 : 1;
			if ($result == 1) {
				$gAssocList{$kSessionIDCookie} = $sessionID;
				$gAssocList{$kUserIDCookie} = $userID;
				my(@record) = ();
				&UMGetUser($userID, \@record);
				$gAssocList{$kUserAccessCookie} = $record[$kUserTypeIndex];
				$gAssocList{$kAnonymousUserCookie} = defined($isanonymous) ? 1 : 0;
				$gAssocList{$kLogoutURLCookie} = $logouturl;
				$gAssocList{$kAnonymousLogoutCloseCookie} = $close;
			}
		}
	}
	return $result;
}

1;
