# $Id: ShowCategories.pl,v 1.2 1998/05/26 18:10:10 thyag Exp $
# Copyright InfoPlace Inc., Milpitas, CA, USA, 1996-1998
# Not to be copied, modified or redistributed without written
# permission of InfoPlace.
#
# --------------------------------------------------------------------------------

require "LogMsg.pl";
require "CGIUtility.pl";
require "DocAPI.pl";
require "DocUtils.pl";
require "Listing.pl";

# --------------------------------------------------------------------------------
sub ShowCategories
{
  local($catid, $edit, *assocList, $templateFile, $includePath, $publishMode) = @_;
  my($totalCells, $numCellsPerRow) = (1, 1);

  if (!defined($catid)) {
    $catid = $kRootCategoryID;
  }

  $includePath = $kDocDocPagePath if (!defined($includePath));
  if (!defined($templateFile)) {
	  $templateFile = $kDocDocPagePath . (($catid eq $kRootCategoryID) ? $kDocTopLevelTemplate : $kDocCategoriesTemplate);
  }

  @categoryList = ();
  my(@categoryRecord) = ();
  $result = &OPGetCategory($catid, \@categoryRecord);
  if ($result == $errNone) {
	  @categoryList = ();
	  my(@catIDs) = &SListUnmake($categoryRecord[$kCategoryChildListIndex], $kValueSeperator);
	  my($count) = $#catIDs + 1;
	  my($i);
	  for ($i = 0; $i < $count; $i++) {
		  my(@catRecord) = ();
		  $result = &OPGetCategory($catIDs[$i], \@catRecord);
		  $categoryList[$i] = &SListMake(\@catRecord, $kFieldSeperator);
	  }
	  $assocList{"CategoryParent"} = $catid;
	  $assocList{"DocumentParent"} = "";
	  my($isRoot) = ($catid == $kRootCategoryID);
	  $assocList{"CategoryName"} = $categoryRecord[$kCategoryNameIndex];
	  $assocList{"EscapedCategoryName"} = &EncodeForURL($categoryRecord[$kCategoryNameIndex]);
	  $assocList{"CategoryDescription"} = ($isRoot) ? &ReadInfoBaseDescription($kDocDBRootPath) : ($categoryRecord[$kCategoryDescIndex] || "");
	  if ($count == 0) {
		  $assocList{"NoCategories"} = "No Categories";
	  }
	  else {
		  $assocList{"TABLEEXISTS"} = 1;
		  $assocList{"NoCategories"} = "";
		  $totalCells = &GenCategoryTableCells(\@categoryList, *assocList, $edit);
		  $numCellsPerRow = 2;
	  }
	  $assocList{"CategoryPath"} = ($publishMode ? &XGetCategoryLinkPath($catid) : &GetCategoryLinkPath($catid));
	  &GenerateHTMLFromTemplate($templateFile, $totalCells, $numCellsPerRow, *assocList, $includePath);
  }
  elsif ($result == $errEntryNotFound) {  # category not found ...
	  &LogMsg("ShowCategories: Failed to find category: ${category}");
	  # it is possible that the category is stale, no more there ...
	  &RedirectURL("../cgi-bin/StaleObject.pl?obj=Category");
	  exit 0;
  }
  else {
	  my($errMsg) = "Failed to get list of categories";
	  &LogMsg($errMsg);
	  my($errPage) = $kDocErrPagePath . $kErrInternalErrorTemplate;
	  my(%assoc) = ("Body", $errMsg);
	  &GenerateHTMLPage($errPage, \%assoc, $kDocErrPagePath);
  }
}
