# $Id: ShowFormView.pl,v 1.2 1998/07/14 22:03:55 naga Exp $
# Copyright InfoPlace Inc., Milpitas, CA, USA, 1996-1998
# Not to be copied, modified or redistributed without written
# permission of InfoPlace.
#
# --------------------------------------------------------------------------------

# Contains routines that display form views for a Category/Document/Glossary term

require "LogMsg.pl";
require "CGIUtility.pl";
require "DocAPI.pl";
require "Listing.pl";
require "DocUtils.pl";

# --------------------------------------------------------------------------------
# Outputs the Form page for a category in edit mode
sub ShowCategoryForm {
	local($id, *category, $errorMsg, *assocList) = @_;
	if ($#category == -1) { #empty
		@category = ();
		$result = &OPGetCategory($id, *category);
		if($result != $errNone) { # handle error
			&RedirectURL("../cgi-bin/StaleObject.pl?obj=Category");
			exit 0;
			local($errPage) = $kDocErrPagePath . $kErrInternalErrorTemplate;
			$assocList{"Body"} = "Category ${name} not found!";
			&GenerateHTMLPage($errPage, *assocList, $kDocErrPagePath);
		}
	}
	$templateFile = $kDocDocPagePath . $kDocEditCategoryTemplate;
	$category[$kCategoryCreationTimeIndex] = &GetTimeFormatted($category[$kCategoryCreationTimeIndex]);
	$category[$kCategoryModificationTimeIndex] = &GetTimeFormatted($category[$kCategoryModificationTimeIndex]);
	my(%al) = &GenerateAssocList(*kCategoryDBFields, *category);
	$assocList{"errorMsg"} = $errorMsg;
	&MergeAssocList(*assocList, \%al);
	$assocList{"CategoryID"} = $id;
	$assocList{"Parent"} = &GetCategoryParentSelectList($category[$kCategoryParentIndex], $id);
	&GenerateHTMLPage($templateFile, *assocList, $kDocDocPagePath);
}

# --------------------------------------------------------------------------------
# Outputs the Form page for a document in edit mode
sub ShowDocumentForm {
	local($docID, *document, $errorMsg, *assocList) = @_;
	if ($#document == -1) { #empty
		@document = ();
		$result = &OPGetDocument($docID, *document);
		if($result != $errNone) { # handle error
			&RedirectURL("../cgi-bin/StaleObject.pl?obj=Document");
			exit 0;
		}
	}
   	$templateFile = $kDocDocPagePath . $kDocEditDocumentTemplate;
	$document[$kDocCreationTimeIndex] = &GetTimeFormatted($document[$kDocCreationTimeIndex]);
	$document[$kDocModificationTimeIndex] = &GetTimeFormatted($document[$kDocModificationTimeIndex]);
	my($url) = $document[$kDocURLIndex];
	my(%al) = &GenerateAssocList(*kDocumentDBFields, *document);
	$assocList{"errorMsg"} = $errorMsg;
	&MergeAssocList(*assocList, \%al);
	if($url ne '') {
		# check if your is of uploaded file ...
		if (!&IsAbsoluteURLPath($url)) {
			$assocList{"UPLOADEDURL"} = 1;
		}
		$assocList{"URLCHECKED"} = "CHECKED";
		$assocList{"DESCCHECKED"} = "";
	}
	else {
		$assocList{"URLCHECKED"} = "";
		$assocList{"DESCCHECKED"} = "CHECKED";
	}
	my(@parents) = split($kValueSeperator, $document[$kDocCategoryListIndex]);
	$assocList{"Parents"} = &GetDocumentParentSelectList(\@parents);
	&GenerateHTMLPage($templateFile, *assocList, $kDocDocPagePath);
}

1;
