##*****************************************************************************
##
##     File Name:	ShowGroups.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     			Not to be copied, modified or redistributed without written
##     			permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	11/20/96	13:26	N		Original version
##
##*****************************************************************************

require "LogMsg.pl";
require "CGIUtility.pl";
require "UMAPI.pl";
require "UMProfileAPI.pl";
require "Listing.pl";

sub ShowGroups
{
    local(*assocList) = @_;
    my($templateFile) = $kDocDocPagePath . $kDocShowGroupsTemplate;

    # Now, iterate thru the groups ...
    local(@groups) = ();
    
    my($result);
    local(@db) = ();
    $result = &DBOpen($kGroupDB, $kDocDBPath, $kDBReadAccess, *db);
    if ($result == $errNone) {
	local(@profile) = ();
	$result = &DBReadFirstRecord(*db, *profile);
	while (!$result) {
	    push(@groups, &SListMake(*profile, $kFieldSeperator));
	    $result = &DBReadNextRecord(*db, *profile);
	}
	my($groupCount) = $#groups + 1;
	my($columnCount) = 1; # name
	local($totalCellCount) = $columnCount* $groupCount;
	if ($totalCellCount) {
	    $assocList{"NoGroups"} = "";
	    $assocList{"TABLEEXISTS"} = 1;	
	    &BuildGroupTableCells(*groups, $groupCount, 0, *assocList);
	}
	else {
	    $assocList{"NoGroups"} = "No Groups";
	    $assocList{"TABLEEXISTS"} = 0;
	}
	&GenerateHTMLFromTemplate($templateFile, $totalCellCount, $columnCount, *assocList, $kDocDocPagePath);
    }
    else {
	local($errPage) = $kDocErrPagePath . $kErrInternalErrorTemplate;	
	$assocList{"Body"} = "Group DB open failed.";
	&GenerateHTMLPage($errPage, *assocList, $kDocErrPagePath);
    }
    &DBClose(*db);
}
1;
