#
##*****************************************************************************
##
##     File Name:	ShowUsersUtils.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     			Not to be copied, modified or redistributed without written
##     			permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	11/20/96	13:26	N		Original version
##
##*****************************************************************************

require "LogMsg.pl";
require "CGIUtility.pl";
require "UMAPI.pl";
require "UMProfileAPI.pl";
require "Listing.pl";

sub GetUserTypeString {
	my($typeid) = @_;
	if($typeid == $kReadOnlyMode) {
		return "Browse Only";
	}
	elsif($typeid == $kEditMode) {
		return "Browse & Modify";
	}
	elsif($typeid == $kAdminMode) {
		return "Administrator";
	}
	elsif($typeid == $kSuperAdminMode) {
		return "Super Administrator";
	}
	return "";
} #GetUserTypeString

sub ShowUsers
{
    local(*assocList) = @_;
    my($templateFile) = $kDocDocPagePath . $kDocShowUsersTemplate;

    # Now, iterate thru the user profile ...
    local(@users) = ();

    my($result);
    local(@db) = ();
    $result = &DBOpen($kUserProfileDB, $kDocDBPath, $kDBReadAccess, *db);
    if ($result == $errNone) {
		local(@profile) = ();
		$result = &DBReadFirstRecord(*db, *profile);
		while (!$result) {
			@userRecord = ();
			$result = &UMGetUser($profile[$kUserProfileUserIDIndex],*userRecord);
			if($result == $errNone) {
				# append usertype to the record
				$profile[$#kUserProfileDBFields + 1] =  &GetUserTypeString($userRecord[$kUserTypeIndex]);
				push(@users, &SListMake(*profile, $kFieldSeperator));
				$result = &DBReadNextRecord(*db, *profile);
			}
		}
		my($userCount) = $#users + 1;
		my($columnCount) = 3; # userid, name and type
		local($totalCellCount) = $columnCount* $userCount;
		if ($totalCellCount) {
			$assocList{"NoUsers"} = "";
			$assocList{"TABLEEXISTS"} = 1;	
			&BuildUserTableCells(*users, $userCount, 0, *assocList);
		}
		else {
			$assocList{"NoUsers"} = "No Users";
			$assocList{"TABLEEXISTS"} = 0;
		}
		&GenerateHTMLFromTemplate($templateFile, $totalCellCount, $columnCount, *assocList, $kDocDocPagePath);
    }
    else {
		local($errPage) = $kDocErrPagePath . $kErrInternalErrorTemplate;	
		$assocList{"Body"} = "User Profile DB open failed.";
		&GenerateHTMLPage($errPage, *assocList, $kDocErrPagePath);
    }
    &DBClose(*db);
}

1;
