# $Id: UMSessionAPI.pl,v 1.1 1998/05/04 19:50:02 naga Exp $
# Copyright InfoPlace Inc., Milpitas, CA, USA, 1996-1998
# Not to be copied, modified or redistributed without written
# permission of InfoPlace.
#
# --------------------------------------------------------------------------------

# This file contains the APIs to support the User Profile Management

require "UMGlobals.pl";
require "CGIUtility.pl";
require "DBOpen.pl";
require "DBLookUp.pl";
require "DBRemove.pl";

# --------------------------------------------------------------------------------
# UMGetMenuControlAndUserMode($sessionID, $menuControl, $mode)
# Gets the "MenuControl" and "Mode" fields of the SessionDB record 
# for the given $sessionID.
# Args:
#	$sessionID	(string): $sessionID to identify the record
#	$menuControl (integer): value of the field
#	$mode (integer): value of the field
#
#	Return Value(boolean): 0 if got successful, $errOPFailed otherwise

sub UMGetMenuControlAndUserMode {
	local($sessionID, *menuControl, *mode) = @_;
	my($result);
	local(@db) = ();
	local(@record) = ();
	$result = &DBOpen($kSessionDB, $kUMDBPath, $kDBReadAccess, *db);
	if ($result == $errNone) {
		$result = &DBRetreiveRecord(*db, $sessionID, *record);
		if ($result == $errNone) {
		  $menuControl = $record[$kSessionMenuControlIndex];
		  $mode = $record[$kSessionModeIndex];
		}
		&DBClose(*db);
 	}
	return $result;	
}


# --------------------------------------------------------------------------------
# UMGetMenuControl($sessionID, $menuControl)
# Gets the "MenuControl" field of the SessionDB record for the given $sessionID.
# Args:
#	$sessionID	(string): $sessionID to identify the record
#	$menuControl (integer): value of the field
#
#	Return Value(boolean): 0 if got successful, $errOPFailed otherwise

sub UMGetMenuControl {
	local($sessionID, *menuControl) = @_;
	my($result);
	local(@db) = ();
	local(@record) = ();
	$result = &DBOpen($kSessionDB, $kUMDBPath, $kDBReadAccess, *db);
	if ($result == $errNone) {
		$result = &DBRetreiveRecord(*db, $sessionID, *record);
		if ($result == $errNone) {
		  $menuControl = $record[$kSessionMenuControlIndex];
		}
		&DBClose(*db);
 	}
	return $result;	
}

# --------------------------------------------------------------------------------
# UMSetMenuControl($sessionID, $menuControl)
# Sets the "MenuControl" field of the SessionDB record for the given $sessionID.
# Args:
#	$sessionID	(string): $sessionID to identify the record
#	$menuControl (integer): value of the field
#							
#	Return Value(boolean): 0 if got successful,  $errOPFailed otherwise

sub UMSetMenuControl {
	local($sessionID, $menuControl) = @_;
	my($result);
	local(@db) = ();
	local(@record) = ();
	$result = &DBOpen($kSessionDB, $kUMDBPath, $kDBWriteAccess, *db);
	if ($result == $errNone) {
		$result = &DBRetreiveRecord(*db, $sessionID, *record);
		if ($result == $errNone) {
		  $record[$kSessionMenuControlIndex] = $menuControl;
		  $result = &DBReplaceRecord(*db, $sessionID, *record);
		}
		&DBClose(*db);
 	}
	return $result;	
}
