#
##*****************************************************************************
##
##     File Name:	UMSessionAPI.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	10/3/96	16:37	N		Original version
##
##*****************************************************************************

#-------------------------------------------------------------
#
require "IPCgiLib.pl";

#-------------------------------------------------------------
# Globals
$kUploadTempDirectory = "/tmp"; # the default dir to use for temp 

#-------------------------------------------------------------
#
sub GetUploadedFileWithCGIInput
{
  local(*cgi_data,  # The form data
	*cgi_cfn,   # The uploaded file(s) client-provided name(s)
	*cgi_ct,    # The uploaded file(s) content-type(s).  These are
	            #   set by the user's browser and may be unreliable
	*cgi_sfn,   # The uploaded file(s) name(s) on the server (this machine)
	$tempdir    # The directory to use as temp dir to copy the files being uploaded
	) = @_;

  my($ret);

  # When writing files, several options can be set..
  # Spool the files to the /tmp directory
  $kIPCGILIBwritefiles = ($tempdir) ? $tempdir : $kUploadTempDirectory;
 
  # Limit upload size to avoid using too much memory
  $kIPCGILIBmaxdata = $kUploadMaxFileSize; 

  # Start off by reading and parsing the data.  Save the return value.
  # Pass references to retreive the data, the filenames, and the content-type
  $ret = &ReadParse(*cgi_data, *cgi_cfn, *cgi_ct, *cgi_sfn);


  # A bit of error checking never hurt anyone
  if ((!defined $ret) ||  (!$ret)) {
      return 1;
  }
  return 0;
}

#-------------------------------------------------------------
#
sub ExtractJustFileName
{
    my($path) = @_;
    my($filename) = $path;
    my(@elements);
    if ($path =~ m#/#) {
	@elements = split('/', $path);
	$filename = $elements[$#elements];
    }
    elsif ($path =~ m#\\#) {

	   my($pat) = '//';
	   # there seem to be regex problem with below statement, so working around it
	   #@elements = split($pat, $path); 
	   $path =~ tr/\\/\//;
	   @elements = split('/', $path);
	   $filename = $elements[$#elements];
       }
    elsif ($path =~ m#:#) {
	   @elements = split(':', $path);
	   $filename = $elements[$#elements];
       }
    return $filename;
}

#-------------------------------------------------------------
#
sub GenerateUniqueFileName
{
    my($dir, $file) = @_;
	# replace space with underscore char
	$file =~ s/ /_/g;
    $fullpath = $dir . $file;
	if (!(-f $fullpath)) {
		return $file;
	}
	my($extension, $name);
	if ($file =~ /^(.*)(\..*)$/) {
		$extension = $2;
		$name = $1;
	}
	else {
		$extension = "";
		$name = $file;
	}
    my($i) = 2;
	my($new) = $name . "_${i}" . $extension;
    while (-f ($dir . $new)) {
		$i++;
		$new = $name . "_${i}" . $extension;
    }
    return $new;
}

#-------------------------------------------------------------
#
sub CopyFile
{
    my($sourcefile,  $desfile) = @_;
    open(UPFILE, "<$sourcefile");
    open(DNFILE, ">$desfile");
	binmode(UPFILE);
	binmode(DBFILE);
    $buf = "";
    while (read (UPFILE, $buf, 8192)) {
		print DNFILE $buf;
    }
    close(UPFILE);
    close(DNFILE);
}

1;
