#    
##*****************************************************************************
##
##     File Name:	VerifySession.pl
##         Owner:	InfoPlace
##     Copyright:	InfoPlace Inc., Pleasanton, CA, USA, 1996.
##     				Not to be copied, modified or redistributed without written
##     				permission of InfoPlace.
##
##
##*****************************************************************************
##                      R E V I S I O N   H I S T O R Y
##*****************************************************************************
##
##	  Date		Time	Author	Description
##	--------	-----	------	---------------------------------------------
##	09/15/96	12:51	N		Original version
##
##*****************************************************************************

# NOTE: Every CGI which needs to execute under valid session, should 'require'
#       this file. If the session is invalid, it will put a appropriate msg
#       and exit.
# --------------------------------------------------------------------------------
#
require "SessionUtils.pl";
require "CGIUtility.pl";
require "TrackCoverage.pl";

# --------------------------------------------------------------------------------
#
sub VerifySession
{
	if (!&IsValidSession()) {
		$templateFile = $kDocDocPagePath . $kDocGotoLoginPromptTemplate;
		&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
		exit 0;
	}
}

# --------------------------------------------------------------------------------
#
sub VerifyUserAccess
{
	my($accessType) = @_;
	my($allowedAccess) = $gAssocList{$kUserAccessCookie};
	if (($accessType & $allowedAccess) != $accessType) {
		$templateFile = $kDocDocPagePath . $kDocAccessDeniedTemplate;
		&GenerateHTMLPage($templateFile, *gAssocList, $kDocDocPagePath);
		exit 0;
	}
}

# Verify for valid session. If the session valid, all globals are set
# appropriately. Otherwise, it will output 'invalid session' page and
# exit.

&VerifySession();
if($gAssocList{"ShowTemplate"}) {#if in debug mode
	&CoverageLogToFileEnable($kCoverageLogFile);
	my($cgipath) = $0;
	$cgipath =~ s/.*[\\\/]([\w\.\-]+)/$1/g;
	&AddToCoverageLog($cgipath);
}

1;
