# author InfoPlace Inc.
# copyright 1998, InfoPlace Inc.  All Rights Reserved.
# --------------------------------------------------------------
# For a given directory tree, do string replacement
# This is platform independent, 100% pure perl code,
# no "system" calls!
#
# --------------------------------------------------------------
# 
sub DoFileRename
{
  my($filename, $namePattern, $replacePattern) = @_;
  my($newname) = $filename;
  if ($newname =~ s/$namePattern/$replacePattern/g) {
	  if (rename($filename, $newname)) {
		  return true;
	  }
	  else {
		  die "Failed to rename file $filename to $newname\n";
	  }
  }
  else {
	  print "File $filename is unchanged.\n";
  }
}

# --------------------------------------------------------------
#
sub DoRename
{
	my($dirname, $level, $namePattern, $replacePattern) = @_;
	
    # read all file names from the given directory ...
    opendir(FILES, $dirname);
    my(@files);
    @files = readdir(FILES);
    closedir(FILES);

    my($filename, $i);

    # skip "." and "..", so start index from 2
    for ($i = 2; $i < $#files + 1; $i++) {
		$filename = $dirname . "/". $files[$i];
		if (-f $filename) {
			&DoFileRename($filename, $namePattern, $replacePattern);
		}
		elsif ($level > 0) {
			&DoRename($filename, $level - 1, $namePattern, $replacePattern);
		}
    }
}

# --------------------------------------------------------------
# 
sub printUsageAndExit
{
	print "Usage: $0: [-recurse <level>] <directory> <filename-substring> <replacement-string>\n";
	exit 0;
}

# --------------------------------------------------------------
# 
if ($#ARGV == 4 || $#ARGV == 2) {
	my($dir, $level, $namePattern, $replacePattern);
	if ($#ARGV == 2) {
		$dir = $ARGV[0];
		$level = 0;
		$namePattern = $ARGV[1];
		$replacePattern = $ARGV[2];
	}
	else {
		if ($ARGV[0] ne "-recurse") {
			&printUsageAndExit();
		}
		$level = $ARGV[1];
		$dir = $ARGV[2];
		$namePattern = $ARGV[3];
		$replacePattern = $ARGV[4];
	}
	(-d $dir) || die "Error: Directory $dir does not exists.";
	&DoRename($dir, $level, $namePattern, $replacePattern);
} else {
	&printUsageAndExit();
}
exit 0;
