#!/usr/bin/perl
#
#-------------------------------------------------------------
# InfoPlace Inc. Pleasanton, CA, USA
# Copyright 1996, 1997
#-------------------------------------------------------------
# Change History:
# Thyag 12/16/96  Started the change history
#                 Add version number, arbitrary start version
# Thyag 2/25/97   made ReplaceFile from a seperate file into
#                 subroutine
#-------------------------------------------------------------
# ReplaceInFile
#-------------------------------------------------------------
sub ReplaceInFile
{
    local($filename, $searchPattern, $replacePattern) = @_;

#    print "In File: $filename Search: $searchPattern Replace: $replacePattern\n";

    local($savedfile) = $filename . ".tmp";
	system("cp -p $filename $savedfile"); # to maintain same file permissions

	open(FILEIN, "<$filename")  || die "Could not open file $filename : $!\n";
    open(FILEOUT, ">$savedfile")  || die "Could not open file $savedfile : $!\n";
    local($didReplace) = 0;
    local($file);
    $file = <FILEIN>;
    if ($file =~ s/
//g) {
	$didReplace = 1;
    }
    print FILEOUT $file;
    
    close(FILEIN);
    close(FILEOUT);
    
    if ($didReplace) {
	system("mv $filename ${filename}.save");
	system("mv $savedfile $filename");
#       print "Replaced in file $filename\n";
    }
    else {
	system("rm $savedfile");
	print "Failed to replace in file $filename\n";
    }
    return $didReplace;
}

#-------------------------------------------------------------
# ReplaceInDir
#-------------------------------------------------------------
sub ReplaceInDir
{
    local($recurse, $dirname, $searchPattern, $replacePattern) = @_;

#    print "In Directory: $dirname Search: $searchPattern Replace: $replacePattern\n";

    opendir(FILES, $dirname);
    local(@files);
    @files = readdir(FILES);
    closedir(FILES);
    local($i);
    # skip "." and ".."
    local($filename);
    for ($i = 2; $i < $#files + 1; $i++) {
	$filename = $dirname . "/". $files[$i];
#	print "file: $filename\n";
	if (-f $filename) {
	    &ReplaceInFile($filename, $searchPattern, $replacePattern);
	}
	elsif ($recurse && (-d $filename)) {
	    &ReplaceInDir($recurse, $filename, $searchPattern, $replacePattern);
	}
    }
}


# begin execution ...
#-------------------------------------------------------------
($#ARGV == 0) || (($#ARGV == 1) && ($ARGV[1] eq '-r')) || 
    die "Format:   $0: <directory> [-r]\n";

$index = 0;
$recurse = 0;
$directory = $ARGV[$index++];
if ($#ARGV == 1) {
    $recurse = 1;
    $index++;
}
$searchPattern = $ARGV[$index++];
$replacePattern = $ARGV[$index];
local($/);
if (-f $replacePattern) { # replacePattern is a filename
    # file contains the replacement string
    open(REPLACEIN, "<$replacePattern")  || die "Could not open file $replacePattern : $!\n";
    $replacePattern = <REPLACEIN>;
    close(REPLACEIN);
}

(-d $directory) || die "directory '$directory' does not exists";
&ReplaceInDir($recurse, $directory, $searchPattern, $replacePattern);
exit 0;
